<?php $label = ""; 

if( !isset($link_row) )
	return false;

if( property_exists($link_row, 'label' ) ){
	$label = $link_row->label; 
}else if( property_exists($link_row, 'text' ) ){
	$label = $link_row->text; 
}

//if still not set..
if( $label == "" )
	$label = ( $link_row->is_amazon == 1)? "Amazon" : "Link";

$status_class = isset($link_row->status)? $link_row->status : "";
$last_checked = "";

if( isset($link_row->last_checked) ){

	//compare last checked time with common labels
	if( $link_row->last_checked > strtotime('today') ){
		$last_checked = "Checked today";
	}else if( $link_row->last_checked > strtotime('yesterday') ){
		$last_checked = "Checked yesterday";
	}else if( $link_row->last_checked > strtotime('-2 day') ){
		$last_checked = "Checked two days ago";
	}else if( $link_row->last_checked > strtotime('-1 week') ){
		$last_checked = "Checked last week";
	}
}

switch ($status_class) {

	case 'ok':
	case 'in-stock':
		$status_message = "Product URL OK";
		break;
		
	case 'out-of-stock':
		$status_message = "Product out of stock";
		break;

	case 'unknown':
	case 'on-backorder':
    case 'not-allowed':
		$status_message = "Status Unknown - Check Product URL";
		break;

	case 'four-oh-four':
	case '404':
		$status_message = "Product URL returns 404 (Not Found)";
		break;
	
	default:
		$status_message = "";

		break;
}
$status_icon = ($status_class == "")? "" : '<div class="product-status ' . $status_class . ' tooltip" title="' . $status_message . '"></div>';
//dd($link_row);
?>

<tr class="row-view" data-id="<?php echo $link_row->hash; ?>" data-nonce="<?php echo wp_create_nonce( 'view_edit_affiliate_' . $link_row->hash ); ?>">
	<?php /* if( $params['context'] == 'link-manager'){ ?>

		<td class="edit-column" >
	        <a class="check-link centered-vertically" title="Check Availability" alt="Check Availability" >
	            <i class="fa fa-eye"></i>
	        </a>
	        <a class="edit centered-vertically">
	            <i class="fa fa-pencil-square-o"></i>
	        </a>
	        <a class="delete centered-vertically" data-nonce="<?php echo wp_create_nonce( 'view_delete_affiliate_' . $link_row->hash ); ?>">
	            <i class="fa fa-trash"></i>
	        </a>
	    </td>

	<?php }else{ ?>

		<!--<td class="centered"><span class="icon-hyperlink-2-1"></span></td>-->		

	<?php } */ ?>

	<td><?php echo $label; ?></td>	

	<?php if( $params['context'] == 'link-manager'){ ?> 
		<td class="status-column align-center">
			<span class="status-spinner"><i class="fa fa-spinner fa-spin"></i></span>
			<span class="product-status <?php echo $status_class; ?>"><?php echo ($link_row->status) ? ucwords(str_replace( array('_', '-') ," ", $link_row->status)): 'Created'; ?></span>
			<span class="last-checked"><?php echo $last_checked; ?></span></td>
	<?php } ?>

	<?php //strip protocol from url
	$stripped_url = str_replace(array('http://', 'https://', 'www.'), '', $link_row->url ); ?>
	<td class="row <?php echo $status_class; ?>"> <?php //echo $status_icon; ?><?php echo $GLOBALS['income_school']['refer_affiliates']->get_link_icon($link_row->url); ?><a class="link" href="<?php echo $link_row->url; ?>" target="_blank"><?php echo $stripped_url; ?></a></td>
	<td class="align-center"><span class="link-clicks"><!--<span class="icon-hyperlink-2-1"></span> --><?php echo ($link_row->clicks30) ? $link_row->clicks30 : '0'; ?></span></td>
	<td class="align-center"><span class="copy-link" data-href="<?php echo $link_row->url; ?>">Copy Link</span></td>
</tr>
