<?php
$startDate = new DateTime();
$endDate = new DateTime();
$endDate->add(new DateInterval("P7D"));
?>
<h3>Create New Clock</h3>
<div class="row-add row fields" data-nonce="<?php echo wp_create_nonce('add_countdown'); ?>">
    <div class="loader"><div class="loading-message"><i class="fa fa-spin fa-spinner"></i> Loading</div></div>
    
    <div class="coulmn-1 col-md-4">

        <div class="field">
            <label for="clock_name">Name Your Clock</label>
            <input type="text" name="clock_name" placeholder="Name Your Clock" value=""/>
        </div>

        <div class="field">
            <label for="purchase_link">Product URL <span class="info-icon tooltip" title="<p>Must have a valid URL prefix ie: http:// or https://</p>"><i class="fa fa-info" aria-hidden="true"></i></span></label>
            <input type="text" name="purchase_link"  placeholder="https://www.link.com" value=""/>
        </div>

        <div class="field checkbox">
            <label for="display_timer_dummy">Display Countdown Clock
                <input type="checkbox" id="display_timer_dummy" checked />
                <input type="hidden" name="display_timer" value="checked"/>
            </label>
        </div>

        <div class="field ">
            <label>Sale Duration</label>
            <select name="countdown_ends">
                <option value='date' selected >Specific Date</option>
                <option value='relative'>Relative to User Visit</option>
            </select>
        </div>

        <div class="row sub-row">

            <div class="sub-col col-lg-6 col-md-12 col-sm-6">
                <div class="field product-image">
                    <label for="end_date">Product Image</label>
                    <input class="product-image-field" type="hidden" name="product_image_id" value="" />

                    <div class="media-modal-trigger countdown-product-image countdown-product-image-placeholder centered-vertically">
                        <a href="javascript://" class="product-image-remove product-image-remove-hidden"><span class="icon-remove-circle-1"></span></a>
                        <a href="javascript://" class="product-image-add"><span class="icon-download-circle-1"></span></a>
                    </div>
                </div>

            </div>

            <div class="sub-col col-lg-6 col-md-12 col-sm-6">
                <div class="date field start-date">
                    <label for="end_date">Sale Start</label>
                    <input type="date" placeholder="Date" name="start_date" class="" value="<?php echo $startDate->format('Y-m-d'); ?>">
                    <input type="time" placeholder="Time" name="start_time" value="00:00">
                </div>

                <div class="field date end-date">
                    <label>Sale End</label>
                    <input type="date" name="end_date" class="" value="<?php echo $endDate->format('Y-m-d'); ?>">
                    <input type="time" name="end_time" value="00:00">
                </div>

                <div class="field relative hidden">
                    <label>Time Relative to User Visit (in Minutes):
                        <input type="number" name="relative_time" class="" value="120">
                    </label>
                </div>

                <div class="field relative hidden">
                    <label>Cookie Expiration (in Days):  <span class="info-icon tooltip" title="<p>Days until the user will get a chance to see the clock again after it expires.</p>"><i class="fa fa-info" aria-hidden="true"></i></span>
                        <input type="number" name="cookie_expires" class="" value="60">
                    </label>
                </div>
            </div>

        </div>
    </div>

    <div class="coulmn-2 col-md-4">

        <div class="field">
            <label for="product_name">Product Name</label>
            <input type="text" name="product_name" placeholder="Product Name" value=""/>
        </div>

        <div class="field">
            <label for="product_description">Product Description</label>
            <textarea name="product_description" rows="4" placeholder="Product Description" ></textarea>
        </div>

        <div class="field">
            <label for="call_to_action">Call to Action Text</label>
            <input type="text" name="call_to_action"  placeholder="Call to Action Text" value=""/>
        </div>

        <div class="field">
            <label for="button_label">Header Clock Button Text</label>
            <input type="text" name="button_label" placeholder="Enter Button Text" value="" />
        </div>

        <div class="field">
            <label for="context_button_label">In-Context Clock Button Text</label>
            <input type="text" name="context_button_label" placeholder="Enter Button Text" value="" />
        </div>

        <div class="field">
            <label for="full_price_label">Full-Price Text</label>
            <input type="text" name="full_price_label" placeholder="Enter Button Text" value="" />
        </div>


    </div>

    <div class="coulmn-3 col-md-4">

        <div class="field">
            <label for="timer_position" >Display Locations</label>
            <br>
            <label class="sub-label" for="location_header_home">
                <input type="checkbox" id="location_header_home" />
                <input type="hidden" name="location_header_home" value=""/>
                Header Banner on Home Page
            </label>
            <br>
            <label class="sub-label" for="location_header_pages">
                <input type="checkbox" id="location_header_pages" />
                <input type="hidden" name="location_header_pages" value=""/>
                Header Banner on Pages
            </label>
            <br>
            <label class="sub-label" for="location_post_top">
                <input type="checkbox" id="location_post_top" checked />
                <input type="hidden" name="location_post_top" value="checked"/>
                Bottom of Blog Posts
            </label>
        </div>

        <?php $pages = $GLOBALS['income_school']['refer_affiliates']->get_cpt_names_and_ids('page', 'menu_order', true); ?>
        <div class="field select-pages hidden">
            <label>Pages <span class="info-icon tooltip" title="<p>Shift-click to select multiple.</p>"><i class="fa fa-info" aria-hidden="true"></i></span></label><br>
            <select name="pages[]" multiple>
                <option value="all" selected>All</option>
                <?php foreach ($pages as $id => $name) {
                    printf( '<option value="%s">%s</option>', $id, $name);
                } ?>
            </select>
        </div>

        <?php $posts = $GLOBALS['income_school']['refer_affiliates']->get_cpt_names_and_ids('post', 'menu_order', true); 
        //add additional cpts to post list
			///////TODO
			//////$GLOBALS['income_school']['refer_affiliates']->get_cpt_names_and_ids($post_type, 'menu_order', true);  returns IDs w/o names
			//////acabado_post_types????
        /*foreach ($GLOBALS['income_school']['refer_affiliates']->classes['product_countdown_display']->acabado_post_types as $post_type) {
            // $posts = array_merge($posts, $GLOBALS['income_school']['refer_affiliates']->get_cpt_names_and_ids($post_type, 'menu_order', true) ); 
            $posts[] = $GLOBALS['income_school']['refer_affiliates']->get_cpt_names_and_ids($post_type, 'menu_order', true); 
        }*/ ?>
        <div class="field select-posts hidden">
            <label>Posts <span class="info-icon tooltip" title="<p>Shift-click to select multiple.</p>"><i class="fa fa-info" aria-hidden="true"></i></span></label><br>
			<select name="posts[]" multiple>
                <option value="all" selected>All</option>
                <?php foreach ($posts as $id => $name) {
                    printf( '<option value="%s">%s</option>', $id, $name);
                } ?>
            </select>
        </div>

        <?php //list taxonomies for posts and acabado post types
        $cats = get_categories(); 
        foreach ($GLOBALS['income_school']['refer_affiliates']->classes['product_countdown_display']->acabado_post_types as $post_type) {
            $tax_array = get_object_taxonomies($post_type);
            if( is_array($tax_array) ) {
                foreach ($tax_array as $taxonomy) {
                    $terms = get_terms( array('taxonomy' => $taxonomy));
                    $cats = array_merge($cats, $terms);
                }
            }
        } ?>

        <div class="field select-cats">
            <label>Categories <span class="info-icon tooltip" title="<p>Shift-click to select multiple.</p>"><i class="fa fa-info" aria-hidden="true"></i></span></label><br>
            <select name="cats[]" multiple >
                <option value="all" selected>All</option>
                <?php foreach ($cats as $cat) {
                    printf( '<option value="%s">%s</option>', $cat->term_id, $cat->name);
                } ?>
            </select>
        </div>

        <div class="row sub-row">

            <div class="sub-col col-lg-6 col-md-12 col-sm-6">
                <div class="field color-picker hidden" id="colorpicker_1">
                    <label for="header_background_color">Header Background Color</label>
                    <div class="field-row">
                        <input class="dummy-input" type="text" placeholder="enter color" value="#00AFEF">
                        <input class="colorpicker-input" type="text" placeholder="enter color" id="header_background_color" name="header_background_color" value="#00AFEF" />
                    </div>
                </div>
            </div>

            <div class="sub-col col-lg-6 col-md-12 col-sm-6">
                <div class="field color-picker hidden" id="colorpicker_2">
                    <label for="header_text_color">Header Text Color</label>
                    <div class="field-row">
                        <input class="dummy-input" type="text" placeholder="enter color" value="#FFF">
                        <input class="colorpicker-input" type="text" placeholder="enter color" id="header_text_color"  name="header_text_color" value="#FFF" />
                    </div>
                </div>
            </div>

        </div>

        <div class="row sub-row">

            <div class="sub-col col-lg-6 col-md-12 col-sm-6">
                <div class="field color-picker hidden" id="colorpicker_3">
                    <label for="header_button_color">Header Button Color</label>
                    <div class="field-row">
                        <input class="dummy-input" type="text" placeholder="enter color" value="#FFD661">
                        <input class="colorpicker-input" type="text" placeholder="enter color" id="header_button_color"  name="header_button_color" value="#FFD661" />
                    </div> 
                </div>
            </div>

            <div class="sub-col col-lg-6 col-md-12 col-sm-6">
                <div class="field color-picker hidden" id="colorpicker_4">
                    <label for="header_button_text_color">Header Button Text Color</label>
                    <div class="field-row">
                        <input class="dummy-input" type="text" placeholder="enter color" value="#1F3A4C">
                        <input class="colorpicker-input" type="text" placeholder="enter color" id="header_button_text_color" name="header_button_text_color" value="#1F3A4C" />
                    </div>
                </div>
            </div>

        </div>


        <div class="row sub-row">

            <div class="sub-col col-lg-6 col-md-12 col-sm-6">
                <div class="field color-picker hidden" id="colorpicker_1">
                    <label for="background_color">Background Color</label>
                    <div class="field-row">
                        <input class="dummy-input" type="text" placeholder="enter color" value="#FFF">
                        <input class="colorpicker-input" type="text" placeholder="enter color" id="background_color" name="background_color" value="#FFF" />
                    </div>
                </div>
            </div>

            <div class="sub-col col-lg-6 col-md-12 col-sm-6">
                <div class="field color-picker hidden" id="colorpicker_2">
                    <label for="text_color">Text Color</label>
                    <div class="field-row">
                        <input class="dummy-input" type="text" placeholder="enter color" value="#424242">
                        <input class="colorpicker-input" type="text" placeholder="enter color" id="text_color"  name="text_color" value="#424242" />
                    </div>
                </div>
            </div>

        </div>

        <div class="row sub-row">

            <div class="sub-col col-lg-6 col-md-12 col-sm-6">
                <div class="field color-picker hidden" id="colorpicker_3">
                    <label for="button_color">Button Color</label>
                    <div class="field-row">
                        <input class="dummy-input" type="text" placeholder="enter color" value="#00AFEF">
                        <input class="colorpicker-input" type="text" placeholder="enter color" id="button_color"  name="button_color" value="#00AFEF" />
                    </div> 
                </div>
            </div>

            <div class="sub-col col-lg-6 col-md-12 col-sm-6">
                <div class="field color-picker hidden" id="colorpicker_4">
                    <label for="button_text_color">Button Text Color</label>
                    <div class="field-row">
                        <input class="dummy-input" type="text" placeholder="enter color" value="#FFF">
                        <input class="colorpicker-input" type="text" placeholder="enter color" id="button_text_color" name="button_text_color" value="#FFF" />
                    </div>
                </div>
            </div>

        </div>
        
    </div>

    <input href="#" class="save" type="hidden" />
    <input href="#" class="cancel" type="hidden" />

</div>
