<?php
$startDate = new DateTime();
$endDate = new DateTime();
$endDate->add(new DateInterval("P7D"));

?>
<h3>Editing Clock: <?php echo ( property_exists($countdown, 'clock_name') )? stripslashes($countdown->clock_name) : ""; ?></h3>
<div class="row-edit row fields" data-id="<?php echo __( $countdown->id); ?>" data-nonce="<?php echo wp_create_nonce( 'edit_countdown_' . $countdown->id); ?>" >
    <div class="loader"><div class="loading-message"><i class="fa fa-spin fa-spinner"></i> Loading</div></div>
    
    <div class="coulmn-1 col-md-4">

        <div class="field">
            <label for="clock_name">Name Your Clock</label>
            <input type="text" name="clock_name" placeholder="Name Your Clock" value="<?php echo ( property_exists($countdown, 'clock_name') )? stripslashes($countdown->clock_name) : ""; ?>"/>
        </div>

        <div class="field">
            <label for="purchase_link">Product URL <span class="info-icon tooltip" title="Must have a valid URL prefix ie: http:// or https://"><i class="fa fa-info" aria-hidden="true"></i></span></label>
            <input type="text" name="purchase_link"  placeholder="https://www.link.com" value="<?php echo __( $countdown->purchase_link); ?>"/>
        </div>

        <div class="field checkbox">
            <label for="display_timer_dummy">Display Countdown Clock
                <input type="checkbox" id="display_timer_dummy" <?php echo ($countdown->display_timer == "checked")? "checked" : ""; ?> />
                <input type="hidden" name="display_timer" value="<?php echo __( $countdown->display_timer); ?>"/>
            </label>
        </div>

        <div class="field ">
            <label>Sale Duration</label>
            <select name="countdown_ends">
                <option value='date' <?php echo ($countdown->countdown_ends == "date")? "selected" : ""; ?> >Specific Date</option>
                <option value='relative' <?php echo ($countdown->countdown_ends == "relative")? "selected" : ""; ?> >Relative to User Visit</option>
            </select>
        </div>

        <div class="row sub-row">

            <div class="sub-col col-lg-6 col-md-12 col-sm-6">
                
                <div class="field product-image">
                    <label for="end_date">Product Image</label>
                    <input class="product-image-field" type="hidden" name="product_image_id" value="<?php echo __( $countdown->product_image_id); ?>" />
                    <?php $product_image = wp_get_attachment_image_url( $countdown->product_image_id,'medium'); ?> 
                    <div class="media-modal-trigger countdown-product-image countdown-product-image-placeholder centered-vertically" style="background: url(<?php echo $product_image; ?>);">
                        <a href="javascript://" class="product-image-remove <?php echo ($product_image == "")? 'product-image-remove-hidden' : ''; ?>"><span class="icon-remove-circle-1"></span></a>
                        <a href="javascript://" class="product-image-add <?php echo ($product_image != "")? 'product-image-add-hidden' : ''; ?>"><span class="icon-download-circle-1"></span></a>
                    </div>
                </div>

            </div>

            <div class="sub-col col-lg-6 col-md-12 col-sm-6">

                <div class="date field start-date">
                    <label for="end_date">Sale Start</label>
                    <input type="date" placeholder="Date" name="start_date" class="" value="<?php echo $startDateValue; ?>" >
                    <input type="time" placeholder="Time" name="start_time" value="<?php echo $startTimeValue; ?>" >
                </div>

                <div class="field date end-date">
                    <label>Sale End</label>
                    <input type="date" name="end_date" class="" value="<?php echo $endDateValue; ?>">
                    <input type="time" name="end_time" value="<?php echo $endTimeValue; ?>">
                </div>

                <div class="field relative hidden">
                    <label>Time Relative to User Visit (in minutes):
                        <input type="number" name="relative_time" class="" value="<?php echo __( $countdown->relative_time); ?>">
                    </label>
                </div>
            </div> 

        </div>      
    </div>

    <div class="coulmn-2 col-md-4">

        <div class="field">
            <label for="product_name">Product Name</label>
            <input type="text" name="product_name" placeholder="Product Name" value="<?php echo __( stripslashes($countdown->product_name)); ?>" />
        </div>

        <div class="field">
            <label for="product_description">Product Description</label>
            <textarea name="product_description" rows="4" placeholder="Product Description" ><?php echo ( property_exists($countdown, 'product_description') )? stripslashes($countdown->product_description) : ""; ?></textarea>
        </div>

        <div class="field">
            <label for="call_to_action">Call to Action Text</label>
            <input type="text" name="call_to_action"  placeholder="Call to Action Text" value="<?php echo __( stripslashes($countdown->call_to_action)); ?>"/>
        </div>

        <div class="field">
            <label for="button_label">Header Clock Button Text</label>
            <input type="text" name="button_label" placeholder="Learn More!" value="<?php echo __( stripslashes($countdown->button_label)); ?>" />
        </div>

        <div class="field">
            <label for="context_button_label">In-Context Clock Button Text</label>
            <input type="text" name="context_button_label" placeholder="Learn More!" value="<?php echo __( stripslashes($countdown->context_button_label)); ?>" />
        </div>

        <div class="field">
            <label for="full_price_label">Full-Price Text</label>
            <input type="text" name="full_price_label" placeholder="Learn More!" value="<?php echo __( stripslashes($countdown->full_price_label)); ?>" />
        </div>

    </div>

    <div class="coulmn-3 col-md-4">

        <div class="field">
            <label for="timer_position" >Display Locations <span class="info-icon tooltip" title="If none chosen, shortcode will still display clock."><i class="fa fa-info" aria-hidden="true"></i></span></label>
            <br>
            <label class="sub-label" for="location_header_home">
                <input type="checkbox" id="location_header_home" <?php echo ($countdown->location_header_home == "checked")? "checked" : ""; ?> />
                <input type="hidden" name="location_header_home" value="<?php echo __( $countdown->location_header_home); ?>"/>
                Header Banner on Home Page
            </label>
            <br>
            <label class="sub-label" for="location_header_pages">
                <input type="checkbox" id="location_header_pages" <?php echo ($countdown->location_header_pages == "checked")? "checked" : ""; ?> />
                <input type="hidden" name="location_header_pages" value="<?php echo __( $countdown->location_header_pages); ?>"/>
                Header Banner on Pages
            </label>
            <br>
            <label class="sub-label" for="location_post_top">
                <input type="checkbox" id="location_post_top" <?php echo ($countdown->location_post_top == "checked")? "checked" : ""; ?> />
                <input type="hidden" name="location_post_top" value="<?php echo __( $countdown->location_post_top); ?>"/>
                Bottom of Blog Posts
            </label>
        </div>

        <?php $pages = $GLOBALS['income_school']['refer_affiliates']->get_cpt_names_and_ids('page', 'menu_order', true); ?>
        <div class="field select-pages hidden">
            <label>Pages <span class="info-icon tooltip" title="Shift-click to select multiple"><i class="fa fa-info" aria-hidden="true"></i></span></label><br>
            <select name="pages[]" multiple>
                <?php $temp_array = explode(',', $countdown->pages); ?>
                <option value="all" <?php echo in_array('all', $temp_array)? "selected" : ""; ?> >All</option>
                <?php foreach ($pages as $id => $name) {
                    $selected = in_array($id, $temp_array)? "selected" : "";
                    printf( '<option value="%s" %s >%s</option>', $id, $selected, $name);
                } ?>
            </select>
        </div>

        <?php $posts = $GLOBALS['income_school']['refer_affiliates']->get_cpt_names_and_ids('post', 'menu_order', true); //add additional cpts to post list
        foreach ($GLOBALS['income_school']['refer_affiliates']->classes['product_countdown_display']->acabado_post_types as $post_type) {
           $posts = $posts . $GLOBALS['income_school']['refer_affiliates']->get_cpt_names_and_ids($post_type, 'menu_order', true); 
        } ?>
        <div class="field select-posts hidden">
            <label>Posts <span class="info-icon tooltip" title="Shift-click to select multiple"><i class="fa fa-info" aria-hidden="true"></i></span></label><br>
            <?php //var_dump($countdown->posts); ?>
            <select name="posts[]" multiple>
                <?php $temp_array = explode(',', $countdown->posts); ?>
                <option value="all" <?php echo (in_array('all', $temp_array) || in_array('', $temp_array) )? "selected" : ""; ?> >All</option>
                <?php foreach ($posts as $id => $name) {
                    $selected = in_array($id, $temp_array)? "selected" : "";
                    printf( '<option value="%s" %s >%s</option>', $id, $selected, $name);
                } ?>
            </select>
        </div>

        <?php //list taxonomies for posts and acabado post types
        $cats = get_categories(); 
        foreach ($GLOBALS['income_school']['refer_affiliates']->classes['product_countdown_display']->acabado_post_types as $post_type) {
            $tax_array = get_object_taxonomies($post_type);
            if( is_array($tax_array) ) {
                foreach ($tax_array as $taxonomy) {
                    $terms = get_terms( array('taxonomy' => $taxonomy));
                    $cats = array_merge($cats, $terms);
                }
            }
        } ?>

        <div class="field select-cats">
            <label>Categories <span class="info-icon tooltip" title="Shift-click to select multiple."><i class="fa fa-info" aria-hidden="true"></i></span></label><br>
           <?php //var_dump($countdown->cats); ?>
            <select name="cats[]" multiple >
                <?php $temp_array = explode(',', $countdown->cats); ?>
                <option value="all" <?php echo (in_array('all', $temp_array) || in_array('', $temp_array) )? "selected" : ""; ?> >All</option>
                <?php foreach ($cats as $cat) {
                    $selected = in_array($cat->term_id, $temp_array)? "selected" : "";
                    printf( '<option value="%s" %s >%s</option>', $cat->term_id, $selected, $cat->name);
                } ?>
            </select>
        </div>

        <div class="field">
            <label >Clock Shortcode <span class="info-icon tooltip" title="Click shortcode to copy!"><i class="fa fa-info" aria-hidden="true"></i></span></label>
            <br><span class="copy-content shortcode">[REFERClock id=<?php echo $countdown->id; ?>]</span>
        </div>

        <div class="row sub-row">

            <div class="sub-col col-lg-6 col-md-12 col-sm-6">
                <div class="field color-picker hidden" id="colorpicker_1">
                    <label for="header_background_color">Header Background Color</label>
                    <div class="field-row">
                        <input class="dummy-input" type="text" placeholder="enter color" value="<?php echo isset($countdown->header_background_color)? $countdown->header_background_color : '#FFF'; ?>">
                        <input class="colorpicker-input" type="text" placeholder="enter color" id="header_background_color" name="header_background_color" value="<?php echo isset($countdown->header_background_color)? $countdown->header_background_color : '#FFF'; ?>" />
                    </div>
                </div>
            </div>

            <div class="sub-col col-lg-6 col-md-12 col-sm-6">
                <div class="field color-picker hidden" id="colorpicker_2">
                    <label for="header_text_color">Header Text Color</label>
                    <div class="field-row">
                        <input class="dummy-input" type="text" placeholder="enter color" value="<?php echo isset($countdown->header_text_color)? $countdown->header_text_color : '#424242'; ?>">
                        <input class="colorpicker-input" type="text" placeholder="enter color" id="header_text_color"  name="header_text_color" value="<?php echo isset($countdown->header_text_color)? $countdown->header_text_color : '#424242'; ?>" />
                    </div>
                </div>
            </div>

        </div>

        <div class="row sub-row">

            <div class="sub-col col-lg-6 col-md-12 col-sm-6">
                <div class="field color-picker hidden" id="colorpicker_3">
                    <label for="header_button_color">Header Button Color</label>
                    <div class="field-row">
                        <input class="dummy-input" type="text" placeholder="enter color" value="<?php echo isset($countdown->header_button_color)? $countdown->header_button_color : '#00AFEF'; ?>">
                        <input class="colorpicker-input" type="text" placeholder="enter color" id="header_button_color"  name="header_button_color" value="<?php echo isset($countdown->header_button_color)? $countdown->header_button_color : '#00AFEF'; ?>" />
                    </div> 
                </div>
            </div>

            <div class="sub-col col-lg-6 col-md-12 col-sm-6">
                <div class="field color-picker hidden" id="colorpicker_4">
                    <label for="header_button_text_color">Header Button Text Color</label>
                    <div class="field-row">
                        <input class="dummy-input" type="text" placeholder="enter color" value="<?php echo isset($countdown->header_button_text_color)? $countdown->header_button_text_color : '#FFF'; ?>">
                        <input class="colorpicker-input" type="text" placeholder="enter color" id="header_button_text_color" name="header_button_text_color" value="<?php echo isset($countdown->header_button_text_color)? $countdown->header_button_text_color : '#FFF'; ?>" />
                    </div>
                </div>
            </div>

        </div>

        <div class="row sub-row">

            <div class="sub-col col-lg-6 col-md-12 col-sm-6">
                <div class="field color-picker hidden" id="colorpicker_1">
                    <label for="background_color">Background Color</label>
                    <div class="field-row">
                        <input class="dummy-input" type="text" placeholder="enter color" value="<?php echo isset($countdown->background_color)? $countdown->background_color : '#FFF'; ?>">
                        <input class="colorpicker-input" type="text" placeholder="enter color" id="background_color" name="background_color" value="<?php echo isset($countdown->background_color)? $countdown->background_color : '#FFF'; ?>" />
                    </div>
                </div>
            </div>

            <div class="sub-col col-lg-6 col-md-12 col-sm-6">
                <div class="field color-picker hidden" id="colorpicker_2">
                    <label for="text_color">Text Color</label>
                    <div class="field-row">
                        <input class="dummy-input" type="text" placeholder="enter color" value="<?php echo isset($countdown->text_color)? $countdown->text_color : '#424242'; ?>">
                        <input class="colorpicker-input" type="text" placeholder="enter color" id="text_color"  name="text_color" value="<?php echo isset($countdown->text_color)? $countdown->text_color : '#424242'; ?>" />
                    </div>
                </div>
            </div>

        </div>

        <div class="row sub-row">

            <div class="sub-col col-lg-6 col-md-12 col-sm-6">
                <div class="field color-picker hidden" id="colorpicker_3">
                    <label for="button_color">Button Color</label>
                    <div class="field-row">
                        <input class="dummy-input" type="text" placeholder="enter color" value="<?php echo isset($countdown->button_color)? $countdown->button_color : '#00AFEF'; ?>">
                        <input class="colorpicker-input" type="text" placeholder="enter color" id="button_color"  name="button_color" value="<?php echo isset($countdown->button_color)? $countdown->button_color : '#00AFEF'; ?>" />
                    </div> 
                </div>
            </div>

            <div class="sub-col col-lg-6 col-md-12 col-sm-6">
                <div class="field color-picker hidden" id="colorpicker_4">
                    <label for="button_text_color">Button Text Color</label>
                    <div class="field-row">
                        <input class="dummy-input" type="text" placeholder="enter color" value="<?php echo isset($countdown->button_text_color)? $countdown->button_text_color : '#FFF'; ?>">
                        <input class="colorpicker-input" type="text" placeholder="enter color" id="button_text_color" name="button_text_color" value="<?php echo isset($countdown->button_text_color)? $countdown->button_text_color : '#FFF'; ?>" />
                    </div>
                </div>
            </div>

        </div>

    </div>

    <input href="#" class="save" type="hidden" />
    <input href="#" class="cancel" type="hidden" />

</div>
