<?php //partial to display a chart of clicks

if( $params ){ 

wp_enqueue_style( 'refer-chart' );
wp_enqueue_script( 'refer-chart', array('jquery-ui-tooltip') );
wp_enqueue_style( 'refer-daterangepicker' );
wp_enqueue_script( 'refer-moment-js' );
wp_enqueue_script( 'refer-daterangepicker-js' );

$values = Array();
if( array_key_exists('values', $params) ){
    if( is_array($params['values']) ){
        $values = $params['values'];
    }
} 

if( array_key_exists('reverse', $params) ){
    if( $params['reverse'] == true){
        $values = array_reverse($values);
    }
}
 
if( array_key_exists('period', $params) ){
    $period = $params['period'];
}else{
    //$period = "1-month";
	$period = "30-Days";
}
?>

<div class="refer-chart">

    <?php if( $params['context'] == 'dashboard' ){ ?>
        <div class="key">
            <div class="label">Date Grouping:</div>
            <div>
				<div id="reportrange" style="background: #fff; cursor: pointer; padding: 5px 10px; border: 1px solid #ccc; width: 100%">
					<span class="dashicons dashicons-calendar-alt"></span>&nbsp;
					<span class="daterange"></span> <span class="dashicons dashicons-arrow-down"></span>
				</div>
				<!--<input type="text" class="daterangeX" name="daterange" />-->
                <!--<select class="period-dropdown">
                    <!--<option value="1-week" <?php #echo ($period == "1-week")? 'selected' : ""; ?> >Last 7 Days</option>
                    <option value="1-month" <?php #echo ($period == "1-month")? 'selected' : ""; ?> >Last 30 Days</option>
                    <option value="1-year" <?php #echo ($period == "1-year")? 'selected' : ""; ?> >Last Last 30 Weeks</option>
					<option value="1-year" <?php #echo ($period == "1-year")? 'selected' : ""; ?> >Last Last 30 Months</option>
                </select>-->
            </div>
        </div>
    <?php } ?>

    <div class="graph">
		
        <?php if( count($values) > 0){ ?>
        
            <div class="scale x">
                <?php 
                for ($i=0; $i < count($values); $i++) {                         
                    $index = ($i < 9)? "0" . ($i + 1) : ($i + 1);
                    echo '<div class="numbers"><span class="index " data-index="' . (string)($i + 1) . '">' . $index . '</span></div>';  
                }?>
            </div>

            <div class="bars">

                <?php 
                $max_value = max($values); 
                
                //calculate the maginitude of the scale (number of zeroes)
                //thank you https://stackoverflow.com/questions/28433798/php-get-length-of-digits-in-a-number
                $magnitude = $max_value !== 0 ? floor(log10($max_value) + 1) : 1;
                $num_steps = ($magnitude > 2)? 4 : 3; //number of horizontal gradations

                //add zero every 2 steps, or 3 steps if over 100
                $multiplier = "1";
                for ($i=1; $i < $magnitude; $i=$i) { 
                    $multiplier .= "0";

                    if($i > 2){
                        $i = $i + 4;
                    }else if($i > 1){
                        $i = $i + 3;
                    }else{
                        $i = $i + 1;
                    }
                } 

                $step = ceil(($max_value / $num_steps) / (int)$multiplier) * (int)$multiplier; //round up to the nearest multiplier
                    
                if($step < 1){
                    $step = 1;
                } ?>

                <div class="scale y" data-max-y="<?php echo $step * $num_steps; ?>">

                   <?php for ($n=0; $n <= ($step * $num_steps) ; $n = $n + $step) { 
                        echo '<div><span class="value">' . $n . '</span><span class="dashline"><span></span></span></div>';
                    } ?>

                </div>

                <?php  // graph values on chart
                    //calculate top of y chart's scale
                    $max_y = $step * $num_steps;
                    $i = 0;
                    foreach ($values as $label => $value) {
                        $actual_height = ($max_y == 0 )? 0 :  ((float)$value / $max_y ) * 100;
						if($period == '30-weeks'){
							$week_yr = explode(' ',$label);
							$wk_arr = getStartAndEndDate($week_yr[0], $week_yr[1]);
							$label = $wk_arr['week_start']. ' - '. $wk_arr['week_end'];
						}
                        ?>

                        <div>
                            <span class="bar" style="height: <?php echo $actual_height; ?>%;"  data-label="<?php echo $label; ?>"   data-index="<?php echo $i+1; ?>" data-value="<?php echo $value; ?>" ></span>
                        </div>

                   <?php  $i ++;
                   } //end for loop

                ?>

            </div>

        <?php } else{ ?>

            <p><em>No data found.</em></p>

        <?php } ?>
        
    </div>
    
</div>

<?php } //end if $params ?>