<?php //table to display refer links


if( $params ){ 

wp_enqueue_style( 'refer-table' );
wp_enqueue_script( 'refer-table' , array('jquery') );

$table_index = array_key_exists('table_index', $params)? $table_index = $params['table_index'] : 0;

$limit = false;
if( array_key_exists('limit', $params ) && !isset($_GET['expand' . $table_index ]) ){
    $limit = $params['limit'];
} 

$show_header = array_key_exists('show_header', $params)? $params['show_header'] : true;

global $wpdb;
$tableName = $wpdb->prefix . 'refer_affiliate_links';
$trackingTableName = $wpdb->prefix . 'refer_link_daily_trackings';	
$OrderByClause = "clicks30 DESC, views30 DESC, url DESC";
$sortByStatus = "ASC";
$sortByUrl = "ASC";
$sortByViews = "ASC";
$sortByClicks = "ASC";
$today = date('Y-m-d');
$thirtyDays = date('Y-m-d', strtotime('-30 days'));

//sorting by Querystring
    
if(isset($_GET['sort' . $table_index . 'ByStatus'])) {
    $OrderByClause = "url {$_GET['sort' . $table_index . 'ByStatus']}";
    if($_GET['sort' . $table_index . 'ByStatus'] == 'ASC') {
        $sortByStatus = "DESC";
    }
}
    
if(isset($_GET['sort' . $table_index . 'ByUrl'])) {
    $OrderByClause = "url {$_GET['sort' . $table_index . 'ByUrl']}";
    if($_GET['sort' . $table_index . 'ByUrl'] == 'ASC') {
        $sortByUrl = "DESC";
    }
}

if(isset($_GET['sort' . $table_index . 'ByViews'])) {
    $OrderByClause = "views30 {$_GET['sort' . $table_index . 'ByViews']}";
    if($_GET['sort' . $table_index . 'ByViews'] == 'ASC') {
        $sortByViews = "DESC";
    }
}

if(isset($_GET['sort' . $table_index . 'ByClicks'])) {
    $OrderByClause = "clicks30 {$_GET['sort' . $table_index . 'ByClicks']}";
    if($_GET['sort' . $table_index . 'ByClicks'] == 'ASC') {
        $sortByClicks = "DESC";
    }
}

$query = "SELECT links.*";
	
$query .= ", (SELECT  SUM(daily.clicks) FROM $trackingTableName AS daily
		WHERE daily.date BETWEEN '$thirtyDays' AND '$today'
		AND daily.clicks > 0
		AND links.id = daily.link_id) AS clicks30,";
	
$query .= " (SELECT  SUM(daily.views) FROM $trackingTableName AS daily
		WHERE daily.date BETWEEN '$thirtyDays' AND '$today'
		AND daily.views > 0
		AND links.id = daily.link_id) AS views30";

$query .=  " FROM $tableName AS links ";

// table search
if(isset($_GET['s' . $table_index ])){
	//$query .= ' WHERE "' . $_GET['s' . $table_index ] . '" IN(url,text) ';
	$query .= $wpdb->prepare(' WHERE (text LIKE "%s") OR (label LIKE "%s") OR (url LIKE "%s")', '%'.$_GET['s' . $table_index ].'%', '%'.$_GET['s' . $table_index ].'%', '%'.$_GET['s' . $table_index ].'%' );
}

$query .= " ORDER BY " . $OrderByClause;


if( $limit != false && $limit != ''){
	$query .= " LIMIT {$limit}";
}

//var_dump( $query );

$allinks = $wpdb->get_results( $query );


// var_dump( "sortByUrl = " . $sortByUrl );
// var_dump( "sortByClicks = " . $sortByClicks );

?>


<table id="refer_links_table_<?php echo $table_index; ?>" data-index="<?php echo $table_index; ?>" class="refer-table">

	<?php if( $show_header ){ ?>
		<tr>
			<th class="align-left">REFER LINK NAME </th>		
			<th class="align-center sortable <?php echo ($sortByStatus == 'ASC')? 'asc' : 'desc'; ?>" data-key="<?php echo 'sort' . $table_index . 'ByStatus'; ?>" data-sort-by="<?php echo $sortByStatus; ?>"><span class="icon icon-arrows"></span>STATUS</th>
			<th class="align-left sortable <?php echo ($sortByUrl == 'ASC')? 'asc' : 'desc'; ?>" data-key="<?php echo 'sort' . $table_index . 'ByUrl'; ?>" data-sort-by="<?php echo $sortByUrl; ?>"><span class="icon icon-arrows"></span>&nbsp;LINK</th>
			<th class="align-center sortable <?php echo ($sortByClicks == 'ASC')? 'asc' : 'desc'; ?>" data-key="<?php echo 'sort' . $table_index . 'ByClicks'; ?>" data-sort-by="<?php echo $sortByClicks; ?>"><span class="icon icon-arrows"></span>&nbsp;30-DAY CLICKS</th>
			<th class="align-center">GRAB IT</th>
		</tr>
	<?php } ?>

	<?php foreach ($allinks as $link_row){ 

		include(AFFILIATE_LINK_REFER_PLUGIN_DIR  . '/assets/html/admin/_partials/affiliate-item-row-view.php');

	} ?>

</table>

<?php } //end if $params 