<div class="wrap bootstrap-wrapper wrap-affiliate-link-sherpa wrap-affiliate-link-sherpa-dashboard">

    <div class="page-header clearfix">
        <?php include(AFFILIATE_LINK_SHERPA_PLUGIN_DIR  . '/assets/html/admin/_partials/header-brand.php'); ?>
        <h1 class="page-header-title">Affiliate Link Sherpa</h1>
    </div>

    <p>Affiliate Link Sherpa makes managing your affiliate links super easy. Every Amazon link that you have added and every link you need to add will automatically be "sherpafied". Managing your affiliate links has never been easier.</p>

    <div class="notice notice-info is-dismissible inline">
        <p>
            <?php echo AffiliateLinkSherpa()->classes['sherpa_facts']->getRandomSherpaFact(); ?>
        </p>
    </div>

    <p>Like Affiliate Link Sherpa? This is only one of the many tools that Project 24 members have access to. Find out more at <a href="https://incomeschool.com/sherpaupgrade" target="_blank">incomeschool.com/sherpaupgrade</a>.</p>

    <hr>

    <div class="cols-wrap clearfix">
        <div class="col-wrap col-wrap-left">
            <div class="inside">
                <h2><?php echo __('Amazon Affiliate Links (no date constraints)'); ?></h2>

                <?php if(!empty($amazonLinks)) : ?>
                    <table class="widefat">
                        <tr>
                            <th class="row-title"><a class="sort" href="<?php echo admin_url('admin.php?page=affiliate-link-sherpa') . "&sortProductReportByUrl={$sortByUrl}";?>"><?php echo __( 'Amazon URL' ); ?> <i class="fa fa-sort"></i></a></th>
                            <th><a class="sort" href="<?php echo admin_url('admin.php?page=affiliate-link-sherpa') . "&sortProductReportByClicks={$sortByClicks}";?>"><?php echo __( 'Clicks' ); ?> <i class="fa fa-sort"></i></a></th>
                            <th><a class="sort" href="<?php echo admin_url('admin.php?page=affiliate-link-sherpa') . "&sortProductReportByViews={$sortByViews}";?>"><?php echo __( 'Views' ); ?> <i class="fa fa-sort"></i></a></th>
                        </tr>

                        <?php foreach($amazonLinks as $link) : ?>
                            <tr>
                                <td><a href="<?php echo $link->url; ?>" target="_blank"><?php echo $link->url; ?></a></td>
                                <td><?php echo $link->clicks; ?></td>
                                <td><?php echo $link->views; ?></td>
                            </tr>
                        <?php endforeach; ?>

                    </table>

                    <p><a href="<?php echo admin_url('admin.php?page=affiliate-link-sherpa-api-settings'); ?>">Manage Amazon</a> | <a href="<?php echo admin_url('admin.php?page=affiliate-link-sherpa-reports'); ?>">View Reports</a></p>
                <?php else : ?>
                    <p>
                        No amazon affiliate links found.<br>
                        <a href="<?php echo admin_url('admin.php?page=affiliate-link-sherpa-api-settings'); ?>">Manage Amazon</a>
                    </p>

                <?php endif; ?>

            </div>
        </div>
        <div class="col-wrap col-wrap-right">
            <div class="inside">

                <h2><?php echo __('Other Affiliate Links (no date constraints)'); ?></h2>

                <?php if(!empty($otherLinks)) : ?>
                    <table class="widefat">
                        <tr>
                            <th class="row-title"><a class="sort" href="<?php echo admin_url('admin.php?page=affiliate-link-sherpa') . "&sortOtherReportByUrl={$sortOtherByUrl}";?>"><?php echo __( 'Affiliate URL' ); ?> <i class="fa fa-sort"></i></a></th>
                            <th><a class="sort" href="<?php echo admin_url('admin.php?page=affiliate-link-sherpa') . "&sortOtherReportByClicks={$sortOtherByClicks}";?>"><?php echo __( 'Clicks' ); ?> <i class="fa fa-sort"></i></a></th>
                            <th><a class="sort" href="<?php echo admin_url('admin.php?page=affiliate-link-sherpa') . "&sortOtherReportByViews={$sortOtherByViews}";?>"><?php echo __( 'Views' ); ?> <i class="fa fa-sort"></i></a></th>
                        </tr>

                        <?php foreach($otherLinks as $link) : ?>
                            <tr>
                                <td><a href="<?php echo $link->url; ?>" target="_blank"><?php echo $link->url; ?></a></td>
                                <td><?php echo $link->clicks; ?></td>
                                <td><?php echo $link->views; ?></td>
                            </tr>
                        <?php endforeach; ?>
                    </table>
                    <p><a href="<?php echo admin_url('admin.php?page=affiliate-link-sherpa-other-affiliates'); ?>">Manage Affiliate Links</a> | <a href="<?php echo admin_url('admin.php?page=affiliate-link-sherpa-reports'); ?>">View Reports</a></p>
                <?php else : ?>
                    <p>
                        No other affiliate links found.<br>
                        <a href="<?php echo admin_url('admin.php?page=affiliate-link-sherpa-other-affiliates'); ?>">Manage Affiliate Links</a>
                    </p>

                <?php endif; ?>


            </div>
        </div>
    </div>

    <div class="cols-wrap clearfix">
        <div class="col-wrap col-wrap-left">
            <div class="inside">
                <p>When we created Affiliate Link Sherpa, we originally wanted to offer it exclusively to our students at Income School. As we talked about it, we realized how help this would be to everyone.</p>
                <p>At Income School, we take care of our students, so we added amazing reports functionality for them as part of their membership. Here is a screenshot of the reports. If you want to get reports, check out our course, Project 24. Alongside our course materials, this is one of the many tools Project 24 members have access to. <a target="_blank" href="https://incomeschool.com/sherpaugrade">Learn More</a></p>
            </div>
        </div>
        <div class="col-wrap col-wrap-right">
            <div class="inside">

                <h2><?php echo __('Affiliate Link Sherpa Legal Notices'); ?></h2>

                <p>Click <a target="_blank" href="https://incomeschool.com/sherpalegal">here</a> for Affiliate Link Sherpa Legal Notices.</p>

                <p><a href="<?php echo admin_url('admin.php?page=affiliate-link-sherpa-legal-disclaimers');?>">Manage Disclaimers</a></p>

            </div>
        </div>
    </div>





</div>
