<?php //REFER link-manager  page

include( AFFILIATE_LINK_REFER_PLUGIN_DIR  . '/assets/html/admin/_partials/refer-admin-bar.php'); 
global $wpdb;
?>

<div class="wrap bootstrap-wrapper wrap-affiliate-link-refer wrap-affiliate-link-refer-link-manager">

    <div class="row">

    	<?php /********************************
    	* calculate 30-DAY CLICKS graph values
    	******************************/

		$link_clicks = $GLOBALS['income_school']['refer_affiliates']->get_click_totals(30); 
		//dd($link_clicks);
		//uncomment below for testing
		//$link_clicks = array( 224, 150);

		$number = 0;
		$percentage = 0;
		$arrow = '<i class="fa fa-arrow-down"></i> - ';

		if( is_array($link_clicks) ){
			$number = number_format($link_clicks[0]);
			$difference = abs($link_clicks[0] - $link_clicks[1]);
			if( $link_clicks[1] == 0 ) $link_clicks[1] = 1;
			$percentage_clean = ( $difference / $link_clicks[1]) * 100;
			$percentage = number_format( $percentage_clean );
			//cap at 100% for graph
			$capped = ($percentage_clean > 100) ? 100 : $percentage_clean;
			$arrow = ( $link_clicks[0] >= $link_clicks[1] )? '<i class="fa fa-arrow-up"></i> + ' : '<i class="fa fa-arrow-down"></i> - ';
		} 

		?>

    	<div class="column-eq-height col-sm-3">
	    	<div class="refer-section stat clicks">
	    		<h2 class="title">30-DAY CLICKS ON REFER LINKS</h2>

	    		<div class="stat">
	    			<i class="icon fa fa-shopping-cart"></i>
	    			<span class="number"><?php echo $number; ?></span>
	    		</div>

	    		<div class="graph" ><div class="inner" style="width:<?php echo $capped; ?>%"></div></div>

	    		<div class="note">
	    			<?php echo $arrow . $percentage; ?>% than prior period
	    		</div>

	    	</div>
    	</div>

    	<?php /********************************
    	* calculate AFFILIATE PROGRAMS graph values
    	******************************/

    	//programs are consdered diferent hostnames of URLs
		$programs = array(); 
		$tableName = $wpdb->prefix . 'refer_affiliate_links';
		$target = 15;
		$links = $wpdb->get_results("SELECT DISTINCT(url) FROM $tableName");

		foreach ($links as $link) {
			$url = parse_url($link->url);
			if( !in_array($url['host'], $programs)){
				$programs[] = $url['host'];
			}
		}
		$count = count($programs);
		$percentage_clean = ( $count / $target) * 100;
		$percentage = number_format($percentage_clean);
		//cap at 100% for graph
		$capped = ($percentage_clean > 100) ? 100 : $percentage_clean;

		?>
    	
    	<div class="column-eq-height col-sm-3">
	    	<div class="refer-section stat affiliates">

	    		<h2 class="title">AFFILIATE PROGRAMS</h2>

	    		<div class="stat">
	    			<span class="icon icon-users"></span>
	    			<span class="number"><?php echo number_format($count); ?></span>
	    		</div>

	    		<div class="graph" ><div class="inner" style="width:<?php echo $capped; ?>%"></div></div>

	    		<div class="note">
	    			<span class="message">Sign up for at least <?php echo $target; ?> to reach the goal</span>
	    		</div>

	    	</div>
    	</div>

    	<?php /********************************
    	* calculate TOTAL REFER LINKS graph values
    	******************************/
    	
    	$tableName = $wpdb->prefix . 'refer_affiliate_links';
		$wpdb->get_results("SELECT * FROM $tableName");
    	$all_links_count = number_format($wpdb->num_rows);
    	// $num_posts = count(get_posts());

    	//get number of posts within the set of types
		$post_types = $GLOBALS['income_school']['refer_affiliates']->classes['product_countdown_display']->acabado_post_types;
		$post_types[] = 'post';
		$post_types_str = implode(' ', $post_types);
		$tableName = $wpdb->prefix . 'posts';
		$wpdb->get_results("SELECT * FROM $tableName WHERE INSTR('" . $post_types_str . "', post_type ) > 0 ");
		$num_posts = number_format($wpdb->num_rows);

    	$target = 1;
    	$divisor = ($num_posts == 0 )? $target : $target * $num_posts;
		$percentage_clean = ($all_links_count / $divisor) * 100;
		$percentage = number_format( ( $all_links_count / $divisor) * 100 );
		//cap at 100% for graph
		$capped = ($percentage_clean > 100) ? 100 : $percentage_clean;
		?>

    	
    	<div class="column-eq-height col-sm-3">
	    	<div class="refer-section stat total-links">
	    		<h2 class="title">TOTAL REFER LINKS</h2>

	    		<div class="stat">
	    			<span class="icon icon-hyperlink-2-1"></span>
	    			<span class="number"><?php echo $all_links_count; ?></span>
	    		</div>

	    		<div class="graph"><div class="inner" style="width:<?php echo $capped; ?>%"></div></div>

	    		<div class="note">
	    			<span class="message"> Goal is <?php echo $target; ?> new REFER link<?php echo ($target > 1)? 's' : ""; ?> per post on your site</span> <?php /*<span class="percentage"><?php echo $percentage; ?></span>% */ ?>
	    		</div>

	    	</div>
    	</div>

		<?php /********************************
    	* calculate NON AMZN REFER LINKS graph values
    	******************************/
    	$tableName = $wpdb->prefix . 'refer_affiliate_links';
		$wpdb->get_results("SELECT * FROM $tableName WHERE is_amazon = 0");
    	$non_amazon_links_count = number_format($wpdb->num_rows);
    	$divisor = ($all_links_count == 0 )? 1 : $all_links_count;
		$percentage_clean = ($non_amazon_links_count / $divisor) * 100;
		$percentage = number_format( $percentage_clean );
		//cap at 100% for graph
		$capped = ($percentage_clean > 100) ? 100 : $percentage_clean;
		?>
    	
    	<div class="column-eq-height col-sm-3">
	    	<div class="refer-section stat non-amazon-links">
	    		<h2 class="title">NON-AMAZON REFER LINKS</h2>

	    		<div class="stat">
	    			<span class="icon icon-hyperlink-2-1"></span>
	    			<span class="number"><?php echo $percentage; ?>%</span>
	    		</div>

	    		<div class="graph"><div class="inner" style="width:<?php echo $capped; ?>%"></div></div>

	    		<div class="note">
	    			<span class="message">Goal is >50% of links are non-Amazon</span>
	    		</div>

	    	</div>
    	</div>

    </div>

    <div id="refer_links" class="refer-table-wrap refer-section affiliates-edit">

    	<?php $table_index = 1; ?>
       
        <div class="refer-links-header">
            
            <div class="col-sm-8 table-search" data-table_index="1">
	            <span class="centered-vertically"><i class="icon fa fa-search" aria-hidden="true"></i></span>
	            <span class="centered-vertically search-message"><?php echo (isset($_GET['s' . $table_index]))? $_GET['s' . $table_index] : 'Search your REFER links.  For example, “Leupold Binoculars”'; ?></span>
	            <input class="search-field centered-vertically" type="text" placeholder="search" value="<?php echo (isset($_GET['s0']))? $_GET['s0'] : ''; ?>" />
	            <span class="refer-button hover-effect search">Search</span>
	        </div>

	        <div class="col-sm-4 align-right">
	       		<a href="<?php echo admin_url(); ?>admin.php?page=affiliate-link-refer-link-manager" class="refer-button hover-effect create" data-toggle="modal" data-target="#add-link-modal"><span class="centered-vertically"><span class="icon icon-megaphone"></span></span>Create New REFER Link</a>
	       </div>

        </div>

        
        <?php 

        $params = Array(
            'context' => 'link-manager',
            // 'limit' => '10',
            'table_index' => $table_index,
        );

        $GLOBALS['income_school']['refer_affiliates']->get_template_part_with_params('admin/_partials/refer-links-table.php', $params ); 

        ?>

    </div>

   <!--  <div class="expand-table <?php #echo isset($_GET['expand' . $table_index ])? 'expanded': '' ; ?>" data-table_index="1" >
    	<i class="icon fa fa-chevron-down"></i>
    </div> -->

	<!--<div id="modal" class="modal-affiliate-link-refer affiliate-item-row-add hidden">-->
	<div id="add-link-modal" class="modal modal-affiliate-link-refer affiliate-item-row-add" tabindex="-1" role="dialog">
		<?php include(AFFILIATE_LINK_REFER_PLUGIN_DIR  . '/assets/html/admin/_partials/affiliate-item-row-add.php'); ?>
	</div>

</div>
