<?php
//get functions from Income School to display in admin

//create cron schedule for notifications
/*add_filter('cron_schedules', function($schedules) {

    $schedules['is_twohour_interval'] = array(
        'interval' => 7200,
        'display' => 'IS Two Hours',
    );
    return $schedules;
}, 99);
*/
//call the cron job according to schedule
add_action('init', function() {
    if(!wp_next_scheduled( 'income_school_refer_notifications')) {
        wp_schedule_event( time(), 'refer_fifteen_min_interval', 'income_school_refer_notifications' );
    }
});

add_action('income_school_refer_notifications', 'get_refer_messages');
function get_refer_messages() {
    $stored_notif = get_option('is_refer_notifications');

    try {
        $response = wp_remote_get( AFFILIATE_LINK_NOTIFICATION_SERVER . '/wp-json/wp/v2/is_notification/?_embed&categories=refer', array( 'timeout' => 20, 'sslverify' => false ) );// _embed makes the response include term names instead of just IDs
        //error_log( '$response = ' . print_r( $response, 1 ) );
        //return '<pre>'.print_r( $response, 1 ).'</pre>';
        $notif_arr = [];
        if ( is_array( $response ) && ! is_wp_error( $response ) ) {
            //error_log( '$response[body] = ' . $response['body'] );
            $return_val = json_decode( $response['body'] );
            //return '<pre>'.print_r( $return_val, 1 ).'</pre>';
            if( is_array($return_val)  || is_object($return_val) ){
                foreach($return_val as $notification){
                    $id = $notification->id;
                    $post_modified = str_replace('T', ' ', $notification->modified_gmt);
                    if(isset($stored_notif[$id]) && $stored_notif[$id]['modified'] <= $post_modified) {//no change
                        $notif_arr[$id]['dismissed'] = $stored_notif[$id]['dismissed'];
                    }else{
                        $notif_arr[$id]['dismissed'] = '0';
                    }
                    
                    $notif_arr[$id]['modified'] = $post_modified;
                    $notif_arr[$id]['title'] = $notification->title->rendered;
                    $notif_arr[$id]['content'] = preg_replace("/<img[^>]+\>/i", "", $notification->content->rendered);//strip img tags
                    $notif_arr[$id]['dismissed'] = '0';
                    $all_terms = $notification->_embedded->{'wp:term'};
                    $notif_arr[$id]['status'] = 'notice-success';
                    if(is_array($all_terms)){
                        foreach($all_terms as $terms){
                            foreach($terms as $term){
                                if($term->id == $notification->is_notification_status[0]){
                                    if($term->slug == 'info'){
                                        $notif_arr[$id]['status'] = 'notice-success';
                                    }else if($term->slug == 'notice') {
                                        $notif_arr[$id]['status'] = 'notice-warning';
                                    }else if($term->slug == 'warning') {
                                        $notif_arr[$id]['status'] = 'notice-error';
                                    }
                                }
                            }
                        }
                    }
                }
                $now =  gmdate('Y-m-d H:i:s', time());
                update_option( 'is_refer_notifications_last_check', $now );
                update_option( 'is_refer_notifications', $notif_arr );
            }
        }else {
            //error_log(print_r($response, 1));
        }
    }
    catch ( Exception $ex ) {
        //echo '<p style="color: red">Error retrieving latest Acabado version number from incomeschool.com</p>';
    }
}

function generate_refer_admin_notice($show_dismissed = false){
    $is_notifications = get_option('is_refer_notifications');
    $output = false;

    // var_dump("FOOOOO");
    // var_dump($is_notifications);

    if(is_array($is_notifications)) {
        $dismis_btn = '<button type="button" class="dismiss-refer-notice"><span class="screen-reader-text">Dismiss this notice.</span></button>';
        //$dismis_btn = '';
        foreach($is_notifications as $id => $notification) {
          if($notification['dismissed'] == '0' || $show_dismissed) {

              $classes = $notification['status'].' dismissable-refer-notice refer-notice refer-notice-'.$id;
              if($show_dismissed) {
                  $classes = $notification['status'].' refer-notice refer-notice-'.$id;
              }

              $content = preg_replace("/<img[^>]+\>/i", "", $notification['content']);//strip img tags
              $output .= '<div class="'.$classes.'" data-id="'.$id.'">'.$content.$dismis_btn.'</div>';
          }
        }
    }
    /*if($show_dismissed) {
        return $output;
    }else{
        echo $output;
    }*/
    return $output;
}

function display_refer_admin_notice($manager_page = false){
    if($manager_page) {
        return generate_refer_admin_notice(true);
    }
}

function count_refer_admin_notice(){
    $is_notifications = get_option('is_refer_notifications');
    if(is_array($is_notifications)) {
        $count = 0;
        foreach($is_notifications as $id => $notification) {
            if($notification['dismissed'] != '1')
                $count++;
        }
        //$count = count($is_notifications);
        if($count > 0){
            return '<span class="notification_count">'.$count.'</span>';
        }else{
            
           return false;
        }
    }else{
        //return '<span class="notification_count">3</span>';
    }
    
}

add_action('wp_ajax_dismiss_refer_notice', 'dismiss_refer_notice');
function dismiss_refer_notice() {
    $id = $_POST['post_id'];
    $is_notifications = get_option('is_refer_notifications');
    if(is_array($is_notifications)) {
        $is_notifications[$id]['dismissed'] = "1";
    }
    update_option( 'is_refer_notifications', $is_notifications );
    wp_send_json_success($id);
}
?>