<?php //REFER reports page

include( AFFILIATE_LINK_REFER_PLUGIN_DIR  . '/assets/html/admin/_partials/refer-admin-bar.php'); 
wp_enqueue_style( 'refer-table' );
wp_enqueue_script( 'refer-table' , array('jquery') );
?>

<div class="wrap bootstrap-wrapper wrap-affiliate-link-reports affiliates-reports-dashboard">

    <div class="row">

        <div class="col-sm-12"> 

                <form class="field select report-filters">
                    <input type="hidden" name="page" value="<?php echo $page;?>">
                    <select name="numDays" id="date-range" onchange='this.form.submit()'>
                        <option <?php if($numDays == 30) { echo ' selected';}?> value="30">Last 30 Days</option>
                        <option <?php if($numDays == 210) { echo ' selected';}?> value="210">Last 30 Weeks</option>
                        <option <?php if($numDays == 900) { echo ' selected';}?> value="900">Last 30 Months</option>
                    </select>

                    <select name="affiliateType" id="affiliate-type"  onchange='this.form.submit()'>
                        <option <?php if($affiliateType == 'all') { echo ' selected';}?> value="all">All Affiliate Programs</option>
                        <option <?php if($affiliateType == 'amazon') { echo ' selected';}?> value="amazon">Amazon-only Affiliate</option>
                        <option <?php if($affiliateType == 'other') { echo ' selected';}?> value="other">Non-Amazon Affiliate</option>
                    </select>

                    <span class="info-icon tooltip" title="<p>Update date range and select a specific affiliate program to further narrow down the report data.</p>"><i class="fa fa-info" aria-hidden="true"></i></span>
                </form>
        </div>

    </div>
    
    <div class="row reports-row">

        <div class="col-wrap col-lg-6">

            <div class="refer-header">
                <div class="title">
                    <div class="icon"><span class="icon-reports"></span></div>
                    <h3>Total Affiliate Clicks</h3> 
                    <a class="link-bubble" href="<?php echo admin_url('admin.php?page=affiliate-link-refer-report-by-post');?>">View all</a>
                </div>
            </div>
            
            <div class="refer-section">
            
            <?php if($affiliatesChartData) {
                if($numDays == 1) {
                    $chartLabel = "Last 24 Hours";
                } elseif($numDays == 365) {
                    $chartLabel = "Last Year";
                } else {
                    $chartLabel = "Last {$numDays} Days";
                }
                ?>
                           
                <?php 
                $period = '30-Days';
                if( array_key_exists('numDays', $_GET) ){

                     switch ( $_GET['numDays']) {
                         
                         case 30:
                             $period = '30-days';
                             break;
                         
                         case 210:
                             $period = '30-weeks';
                             break;
                         
                         default:
                         case 900:
                             $period = '30-months';
                             break;
                     }
                }

                $dates = $GLOBALS['income_school']['refer_affiliates']->get_link_clicks($period);

                $params = Array(
                    // 'values' => $dates,
                    'values' => $affiliatesChartData,
                    'context' => 'reports',
                    'period' => $period,
                    'reverse' => true,
                );
					function getStartAndEndDate($week, $year) {
						$dto = new DateTime();
						$dto->setISODate($year, $week);
						$ret['week_start'] = $dto->format('m/d');
						$dto->modify('+6 days');
						$ret['week_end'] = $dto->format('m/d, Y');
						return $ret;
					}

                // var_dump($affiliatesChartData);
                $GLOBALS['income_school']['refer_affiliates']->get_template_part_with_params('admin/_partials/refer-chart.php', $params ); 

                ?>

            <?php }else{
                //
				echo '<em>No data found.</em>';
            } //end if ?>

            </div>
        </div>

        <div class="col-wrap col-lg-6">

            <div class="refer-header">
                <div class="title">
                    <div class="icon"><span class="icon-reports"></span></div>
                    <h3>Total Clock Clicks</h3> 
                    <a class="link-bubble" href="<?php echo admin_url('admin.php?page=affiliate-link-refer-product-countdowns#clocks_bottom');?>">View all</a>
                </div>
            </div>
            
            <div class="refer-section">
            
            <?php 

            if($countdownsChartData) {
                if($numDays == 1) {
                    $chartLabel = "Last 24 Hours";
                } elseif($numDays == 365) {
                    $chartLabel = "Last Year";
                } else {
                    $chartLabel = "Last {$numDays} Days";
                }
                ?>
                           
                <?php 
                $period = '30-days';
                if( array_key_exists('numDays', $_GET) ){

                     switch ( $_GET['numDays']) {
                         
                         case 30:
                             $period = '30-days';
                             break;
                         
                         case 210:
                             $period = '30-weeks';
                             break;
                         
                         default:
                         case 900:
                             $period = '30-months';
                             break;
                     }
                }
                    
                $dates = $GLOBALS['income_school']['refer_affiliates']->get_link_clicks($period);
                $params = Array(
                    // 'values' => $dates,
                    'values' => $countdownsChartData,
                    'context' => 'reports',
                    'period' => $period,
                    'reverse' => true,
                );

                // var_dump($countdownsChartData);
                $GLOBALS['income_school']['refer_affiliates']->get_template_part_with_params('admin/_partials/refer-chart.php', $params ); 

                ?>

            <?php }else{
                echo '<em>No data found.</em>';
            } //end if ?>

            </div>
        </div>

    </div>

    <div class="row reports-row">    

        <div class="col-wrap col-lg-6">
            <div class="refer-header">
                <div class="title">
                    <div class="icon"><span class="icon-flip-vertical-down"></span></div>
                    <h3><span>Affiliate Clicks by <span class="sky-blue report-type">Post</span></span></h3> 
                    <a class="link-bubble" href="<?php echo admin_url('admin.php?page=affiliate-link-refer-report-by-post');?>">View all</a>
                </div>
            </div>
            
            <div class="refer-section refer-table-wrap">
                <table class="affiliate-report-table post-stats refer-table">
                    <thead>
                        <tr>
                            <th><a class="sort" href="<?php echo admin_url('admin.php?page=affiliate-link-refer-reports') . "&sortPostReportByTitle={$sortPostReportByTitle}{$currentParams}";?>"><?php echo __( 'Title' ); ?> <i class="fa fa-sort"></i></a></th>
                            <th class="right"><a class="sort" href="<?php echo admin_url('admin.php?page=affiliate-link-refer-reports') . "&sortPostReportByViews={$sortPostReportByViews}{$currentParams}";?>"><?php echo __( 'Views' ); ?> <i class="fa fa-sort"></i></a></th>
                            <th class="right"><a class="sort" href="<?php echo admin_url('admin.php?page=affiliate-link-refer-reports') . "&sortPostReportByClicks={$sortPostReportByClicks}{$currentParams}";?>"><?php echo __( 'Clicks' ); ?> <i class="fa fa-sort"></i></a></th>
                        </tr>
                    </thead>
                    <tbody>
                        <?php if(!count($postStats)) : ?>
                            <tr>
                                <td colspan="3"><em>No data found.</em></td>
                            </tr>
                        <?php else : ?>
                            <?php foreach($postStats as $stat) :?>
                                <tr>
                                    <td class="title"><?php echo $stat['title'];?></td>
                                    <td class="views right"><?php echo $stat['views'];?></td>
                                    <td class="clicks right"><?php echo $stat['clicks'];?></td>
                                </tr>
                            <?php endforeach; ?>
                        <?php endif; ?>
                        <?php for($i = 0; $i < (7 - count($postStats)); $i++) : ?>
                            <tr>
                                <td colspan="3">&nbsp;</td>
                            </tr>
                        <?php endfor; ?>
                    </tbody>
                </table>
            </div>
        </div>    

        <div class="col-wrap col-lg-6">
            <div class="refer-header">
                <div class="title">
                    <div class="icon"><span class="icon-flip-vertical-down"></span></div>
                    <h3><span>Clock Clicks by <span class="sky-blue report-type">Post</span></span></h3> 
                    <a class="link-bubble" href="<?php echo admin_url('admin.php?page=affiliate-link-refer-product-countdowns#clocks_bottom');?>">View all</a>
                </div>
            </div>
            
            <div class="refer-section refer-table-wrap">
                <table class="affiliate-report-table post-stats refer-table">
                    <thead>
                        <tr>
                            <th><a class="sort" href="<?php echo admin_url('admin.php?page=affiliate-link-refer-reports') . "&sortPostReportByTitle={$sortPostReportByTitle}{$currentParams}";?>"><?php echo __( 'Title' ); ?> <i class="fa fa-sort"></i></a></th>
                            <th class="right"><a class="sort" href="<?php echo admin_url('admin.php?page=affiliate-link-refer-reports') . "&sortPostReportByViews={$sortPostReportByViews}{$currentParams}";?>"><?php echo __( 'Views' ); ?> <i class="fa fa-sort"></i></a></th>
                            <th class="right"><a class="sort" href="<?php echo admin_url('admin.php?page=affiliate-link-refer-reports') . "&sortPostReportByClicks={$sortPostReportByClicks}{$currentParams}";?>"><?php echo __( 'Clicks' ); ?> <i class="fa fa-sort"></i></a></th>
                        </tr>
                    </thead>
                    <tbody>
                        <?php 
                        if(!count($countdownPostStats)) : ?>
                            <tr>
                                <td colspan="3"><em>No data found.</em></td>
                            </tr>
                        <?php else : ?>
                            <?php foreach($countdownPostStats as $stat) :?>
                                <tr>
                                    <td class="title"><?php echo $stat['title'];?></td>
                                    <td class="views right"><?php echo $stat['views'];?></td>
                                    <td class="clicks right"><?php echo $stat['clicks'] ? $stat['clicks'] : '0';?></td>
                                </tr>
                            <?php endforeach; ?>
                        <?php endif; ?>
                        <?php for($i = 0; $i < (7 - count($countdownPostStats)); $i++) : ?>
                            <tr>
                                <td colspan="3">&nbsp;</td>
                            </tr>
                        <?php endfor; ?>
                    </tbody>
                </table>
            </div>
        </div>

    </div>
 
    <div class="row reports-row">

        <div class="col-wrap col-lg-6">

            <div class="refer-header">
                <div class="title">
                    <div class="icon"><span class="icon-product"></span></div>
                    <h3><span>Affiliate Clicks by <span class="sky-blue report-type">Product</span></span></h3> 
                    <a class="link-bubble" href="<?php echo admin_url('admin.php?page=affiliate-link-refer-report-by-product');?>">View all</a>
                </div>
            </div>
            
            <div class="refer-section refer-table-wrap">
                <table class="affiliate-report-table post-stats refer-table">
                    <thead>
                        <tr>
                            <th><a class="sort" href="<?php echo admin_url('admin.php?page=affiliate-link-refer-reports') . "&sortProductReportByName={$sortProductReportByName}{$currentParams}";?>"><?php echo __( 'Title' ); ?> <i class="fa fa-sort"></i></a></th>
                            <th class="right"><a class="sort" href="<?php echo admin_url('admin.php?page=affiliate-link-refer-reports') . "&sortProductReportByViews={$sortProductReportByViews}{$currentParams}";?>"><?php echo __( 'Views' ); ?> <i class="fa fa-sort"></i></a></th>
                            <th class="right"><a class="sort" href="<?php echo admin_url('admin.php?page=affiliate-link-refer-reports') . "&sortProductReportByClicks={$sortProductReportByClicks}{$currentParams}";?>"><?php echo __( 'Clicks' ); ?> <i class="fa fa-sort"></i></a></th>
                        </tr>
                    </thead>
                    <tbody>
                        <?php if(!count($productStats)) : ?>
                            <tr>
                                <td colspan="3"><em>No data found.</em></td>
                            </tr>
                        <?php else : ?>
                            <?php foreach($productStats as $stat) :?>
                                <tr>
                                    <td class="title"><?php echo $stat['name'];?></td>
                                    <td class="views right"><?php echo $stat['views'];?></td>
                                    <td class="clicks right"><?php echo $stat['clicks'];?></td>
                                </tr>
                            <?php endforeach; ?>
                        <?php endif; ?>
                        <?php for($i = 0; $i < (7 - count($productStats)); $i++) : ?>
                            <tr>
                                <td colspan="3">&nbsp;</td>
                            </tr>
                        <?php endfor; ?>
                    </tbody>
                </table>
            </div>
        </div>

        <div class="col-wrap col-lg-6">

            <div class="refer-header">
                <div class="title">
                    <div class="icon"><span class="icon-author"></span></div>
                    <h3><span>Affiliate Clicks by <span class="sky-blue report-type">Author</span></span></h3> 
                    <a class="link-bubble" href="<?php echo admin_url('admin.php?page=affiliate-link-refer-report-by-author');?>">View all</a>
                </div>
            </div>
            
            <div class="refer-section refer-table-wrap">
                <table class="affiliate-report-table post-stats refer-table">
                    <thead>
                        <tr>
                          <th><a class="sort" href="<?php echo admin_url('admin.php?page=affiliate-link-refer-reports') . "&sortAuthorReportByName={$sortAuthorReportByName}";?>"><?php echo __( 'Author' ); ?> <i class="fa fa-sort"></i></a></th>
                          <th class="right"><a class="sort" href="<?php echo admin_url('admin.php?page=affiliate-link-refer-reports') . "&sortAuthorReportByViews={$sortAuthorReportByViews}";?>"><?php echo __( 'Views' ); ?> <i class="fa fa-sort"></i></a></th>
                          <th class="right"><a class="sort" href="<?php echo admin_url('admin.php?page=affiliate-link-refer-reports') . "&sortAuthorReportByClicks={$sortAuthorReportByClicks}";?>"><?php echo __( 'Clicks' ); ?> <i class="fa fa-sort"></i></a></th>
                          <th class="right"><a class="sort" href="<?php echo admin_url('admin.php?page=affiliate-link-refer-reports') . "&sortAuthorReportByAvg={$sortAuthorReportByAvg}";?>"><?php echo __( 'Clicks/Post' ); ?> <i class="fa fa-sort"></i></a></th>
                        </tr>
                    </thead>
                    <tbody>
                        <?php if(!count($authorStats)) : ?>
                            <tr>
                                <td colspan="3"><em>No data found.</em></td>
                            </tr>
                        <?php else : ?>
                            <?php foreach($authorStats as $stat) :?>
                                <tr>
                                    <td class="author"><?php echo $stat['name'];?></td>
                                    <td class="views right"><?php echo $stat['views'];?></td>
                                    <td class="clicks right"><?php echo $stat['clicks'];?></td>
                                    <td class="avg right"><?php echo number_format($stat['avg'], 0, '.', ',');?></td>
                                </tr>
                            <?php endforeach; ?>
                        <?php endif; ?>
                        <?php for($i = 0; $i < (7 - count($authorStats)); $i++) : ?>
                            <tr>
                                <td colspan="4">&nbsp;</td>
                            </tr>
                        <?php endfor; ?>
                    </tbody>
                </table>
            </div>
        </div>

    </div>

    <div class="row reports-row">

        <div class="col-wrap col-lg-6">

            <div class="refer-header">
                <div class="title">
                    <div class="icon"><span class="icon-hierarchy-6"></span></div>
                    <h3><span>Affiliate Clicks by <span class="sky-blue report-type">Category</span></span></h3> 
                    <a class="link-bubble" href="<?php echo admin_url('admin.php?page=affiliate-link-refer-report-by-category');?>">View all</a>
                </div>
            </div>
            
            <div class="refer-section refer-table-wrap">
                <table class="affiliate-report-table post-stats refer-table">
                    <thead>
                        <tr>
                            <th><a class="sort" href="<?php echo admin_url('admin.php?page=affiliate-link-refer-reports') . "&sortCatReportByTitle={$sortCatReportByTitle}{$currentParams}";?>"><?php echo __( 'Category' ); ?> <i class="fa fa-sort"></i></a></th>
                            <th class="right"><a class="sort" href="<?php echo admin_url('admin.php?page=affiliate-link-refer-reports') . "&sortCatReportByViews={$sortCatReportByViews}{$currentParams}";?>"><?php echo __( 'Views' ); ?> <i class="fa fa-sort"></i></a></th>
                            <th class="right"><a class="sort" href="<?php echo admin_url('admin.php?page=affiliate-link-refer-reports') . "&sortCatReportByClicks={$sortCatReportByClicks}{$currentParams}";?>"><?php echo __( 'Clicks' ); ?> <i class="fa fa-sort"></i></a></th>
                        </tr>
                    </thead>
                    <tbody>
                        <?php if(!count($taxStats)) : ?>
                            <tr>
                                <td colspan="3"><em>No data found.</em></td>
                            </tr>
                        <?php else : ?>
                            <?php foreach($taxStats as $stat) :?>
                                <tr>
                                    <td class="title"><?php echo $stat['title'];?></td>
                                    <td class="views right"><?php echo $stat['views'];?></td>
                                    <td class="clicks right"><?php echo $stat['clicks'];?></td>
                                </tr>
                            <?php endforeach; ?>
                        <?php endif; ?>
                        <?php for($i = 0; $i < (7 - count($taxStats)); $i++) : ?>
                            <tr>
                                <td colspan="3">&nbsp;</td>
                            </tr>
                        <?php endfor; ?>
                    </tbody>
                </table>
            </div>
        </div>

        <div class="col-wrap col-lg-6">

            <div class="refer-header">
                <div class="title">
                    <div class="icon"><span class="icon-paginate-filter-plus-1"></span></div>
                    <h3><span>Affiliate Clicks by <span class="sky-blue report-type">Word Count</span></span></h3> 
                    <a class="link-bubble" href="<?php echo admin_url('admin.php?page=affiliate-link-refer-report-by-word-count');?>">View all</a>
                </div>
            </div>
            
            <div class="refer-section refer-table-wrap">
                <table class="affiliate-report-table post-stats refer-table">
                    <thead>
                        <tr>
                            <th><a class="sort" href="<?php echo admin_url('admin.php?page=affiliate-link-refer-reports') . "&sortWordCountReportByTitle={$sortCatReportByWordCount}{$currentParams}";?>"><?php echo __( 'Word Count' ); ?> <i class="fa fa-sort"></i></a></th>
                            <th class="right"><a class="sort" href="<?php echo admin_url('admin.php?page=affiliate-link-refer-reports') . "&sortWordCountReportByViews={$sortCatReportByViews}{$currentParams}";?>"><?php echo __( 'Views' ); ?> <i class="fa fa-sort"></i></a></th>
                            <th class="right"><a class="sort" href="<?php echo admin_url('admin.php?page=affiliate-link-refer-reports') . "&sortWordCountReportByClicks={$sortCatReportByClicks}{$currentParams}";?>"><?php echo __( 'Clicks' ); ?> <i class="fa fa-sort"></i></a></th>                      
                        </tr>
                    </thead>
                    <tbody>
                        <?php if(!count($wordCountStats)) : ?>
                            <tr>
                                <td colspan="3"><em>No data found.</em></td>
                            </tr>
                        <?php else : ?>
                            <?php foreach($wordCountStats as $stat) :?>
                                <tr>
                                    <td class="title"><?php echo $stat['title'];?></td>
                                    <td class="views right"><?php echo $stat['views'];?></td>
                                    <td class="clicks right"><?php echo $stat['clicks'];?></td>
                                </tr>
                            <?php endforeach; ?>
                        <?php endif; ?>
                        <?php for($i = 0; $i < (7 - count($wordCountStats)); $i++) : ?>
                            <tr>
                                <td colspan="3">&nbsp;</td>
                            </tr>
                        <?php endfor; ?>
                    </tbody>
                </table>
            </div>
        </div>
    </div>

</div>
