var flipdowns = [];

jQuery(function($) {

    function get_multi_vals( multiselect ){
        str_val = '';
        multiselect.find(':selected').map(function(i, el) {
            str_val += (i != 0)? "," : "";
            str_val += $(el).val();
        }).get();
        return str_val;
    }

    function handle_color_pickers(){

        $('body').on('click', function(e){
            if( $(e.target).parents(".field.color-picker").length == 0){
                $('.wp-picker-active').removeClass('wp-picker-active');
                $('.wp-picker-open').attr('aria-expanded', 'false').removeClass('wp-picker-open');
                $('.wp-picker-input-wrap').addClass('hidden');
                $('.iris-picker').css('display','none');
                $('.colorpicker-input').iris('hide');
            }
        });

        $.each( $(".field.color-picker"), function(i, _this){

            if( $(_this).find('.wp-picker-container').length == 0 ){

                $(_this).find('.colorpicker-input').wpColorPicker({
                    change: function(event, ui) {
                        var color = ui.color.toString();
                        $(_this).find('.dummy-input').attr('value', color );
                    }
                });

                //bind the dummy input to open the picker too
                $(_this).find('.dummy-input').click(function(){ 
                    // // console.log(this);
                    $('.colorpicker-input').iris('hide');
                    $('.wp-picker-active').removeClass('wp-picker-active');
                    $(_this).find('.colorpicker-input').iris('show');
                    $(_this).find('.button.wp-color-result').trigger('click'); 
                });

                //bind clear button to also clear dummy field
                $(_this).find('.button.wp-picker-clear').click(function(){ 
                    $(_this).find('.dummy-input').attr('value', '' );
                });

                //add and bind close button
                // $(_this).find('.wp-picker-clear').after('<span class="dashicons close dashicons-no"></span>');
                // $(_this).find('.close').click(function(){ 
                //     $('.wp-picker-active').removeClass('wp-picker-active');
                //     $('.wp-picker-input-wrap').addClass('hidden');
                //     $('.wp-picker-open').attr('aria-expanded', 'false').removeClass('wp-picker-open');
                //     $('.iris-picker').css('display','none');
                //     $('.colorpicker-input').iris('hide');

                // });

                //finally, show the pickers
                $(_this).removeClass('hidden');
            }

        });

        
    }
    //call it!
    handle_color_pickers();
    handle_tooltips();

    function countdown_ends_visibilty(row){

        var $countdown_ends = $(row).find('select[name="countdown_ends"]');
        
        // console.log( $(row) );
    
        switch( $countdown_ends.val() ){

            case 'date' : 
                $(row).find('div.relative').addClass('hidden');
                $(row).find('div.end-date, div.start-date').removeClass('hidden');
                break;

            case 'relative' : 
                $(row).find('div.end-date, div.start-date').addClass('hidden');
                $(row).find('div.relative').removeClass('hidden');
                break;

        }
    }

    function handle_tooltips(){


        $(".tooltip").tooltip({
            items: "[title]",
            content : function() {
                return '<div class="tip">' + $(this).attr('title') + '</div>';
            },
            position : { 
                my: "left-40 bottom-10 right-40", 
                at: "center-4 top-1", 
                collision: 'flip',
                using: function( position, feedback ) {
                    // console.log(position);
                    // console.log(feedback);
                    $(this).css( position );
                    $(this).addClass( feedback.vertical );
                    $(this).addClass( feedback.horizontal );
                },
            },
            hide: true,
            open: function(event, ui)
            {
                if (typeof(event.originalEvent) === 'undefined')
                {
                    return false;
                }
            
                var $id = $(ui.tooltip).attr('id');
            
                // close any lingering tooltips
                $('div.ui-tooltip').not('#' + $id).remove();
                
                // ajax function to pull in data and add it to the tooltip goes here
            },
            close: function(event, ui)
            {
                ui.tooltip.hover(function()
                {
                    $(this).stop(true).fadeTo(400, 1); 
                },
                function()
                {
                    $(this).fadeOut('400', function()
                    {
                        $(this).remove();
                    });
                });
            }
        });

    }
	

    /**
     * Prevent all links within countdown preview from operating
     */
    $("body").on('click', ".modal-affiliate-link-refer.preview .refer-cd-content a", function(e) {
        // console.log( e.target );
        e.preventDefault();
        e.stopPropagation();
        e.stopImmediatePropagation();
        return false;
    });

    /**
     *
     */
    $("body").on('click', ".refer-cd-close", function(e) {
        $('.modal-affiliate-link-refer.preview').removeClass('preview');
    });

    /**
     *
     */
    $('[name="legal_disclaimers_allow_top_of_post"]').on('change', function(e) {
        if($(this).is(':checked')) {
            $('#collapsingLegalDisclaimersTopOfPost').addClass('in');
        } else {
            $('#collapsingLegalDisclaimersTopOfPost').removeClass('in');
        }
    });

    /**
     *
     */
    $('[name="legal_disclaimers_allow_bottom_of_post"]').on('change', function(e) {
        if($(this).is(':checked')) {
            $('#collapsingLegalDisclaimersBottomOfPost').addClass('in');
        } else {
            $('#collapsingLegalDisclaimersBottomOfPost').removeClass('in');
        }
    });

    /**
     *
     */
    $('[name="legal_disclaimers_allow_footer"]').on('change', function(e) {
        if($(this).is(':checked')) {
            $('#collapsingLegalDisclaimersFooter').addClass('in');
        } else {
            $('#collapsingLegalDisclaimersFooter').removeClass('in');
        }
    });

    /**
     *
     */
    $('[name="legal_disclaimers_allow_sidebar"]').on('change', function(e) {
        if($(this).is(':checked')) {
            $('#collapsingLegalDisclaimersSidebar').addClass('in');
        } else {
            $('#collapsingLegalDisclaimersSidebar').removeClass('in');
        }
    });


    /****************************************************************************************
     **************************** Affiliate Links manager ************************
     ****************************************************************************************/

    /**
     * Affilaite row cache
     * @type {Object}
     */
    var editAffiliateRowsCache = {};


    /**
     *
     */
    $('body').on('click', '.row-add .save', function(e) {
        // console.log("add save");
        e.preventDefault();
        var $this = $(this);
        var row = $this.closest('.row-add');
        var label = row.find('[name="label"]');
        var url = row.find('[name="url"]');
        var text = row.find('[name="text"]');
        var errors = [];

        $('.notice-error-ajax').hide();
        row.addClass('loading');

        if(label.val() == '') {
            errors.push('Label is required.');
            label.addClass('has-error');
        } else {
            label.removeClass('has-error');
        }

        if(url.val() == '') {
            errors.push('Url is required.');
            url.addClass('has-error');
        } else {
            url.removeClass('has-error');
        }

        if(errors.length) {
            $('.notice-error-ajax').html('<p>' + errors.join('<br>') + '</p>').removeClass('notice-success').addClass('notice-error').show();
			row.removeClass('loading');
            return false;
        }

        
        var data = {
            '_wpnonce' : row.data('nonce'),
            'action': 'handle_post_affiliate_add',
            'label' : label.val(),
            'url' : url.val(),
            'text' : text.val()
        };

        $.ajax(ajaxurl, {
            data: data,
            method: 'post',
            dataType: 'json',
            success: function(data) {
                if(data.success == true) {
                    row.removeClass('loading');
                    $('.notice-error-ajax').removeClass('notice-error').addClass('notice-success').html('<p>New Affiliate Link Saved!</p>').show();
                    location.reload();
                } else {
                    row.removeClass('loading');
                    $.each(data.errors, function(k,v) {
                        row.find('[name="' + k + '"]').addClass('has-error');
                        errors.push(v);
                    });
                    $('.notice-error-ajax').html('<p>' + errors.join('<br>') + '</p>').removeClass('notice-success').addClass('notice-error').show();
                }
            },
            fail: function(data) {
                row.removeClass('loading');
                $('.notice-error-ajax').html('<p>There was a problem adding the affiliate.</p>').removeClass('notice-success').addClass('notice-error').show();
            }
        });
    });

    /**
     *
     */
    $('body').on('click', '.affiliates-edit .row-view', function(e) {

        var target  = $(e.target);
        if( !target.is('a, .copy-link, .delete, .delete i, .fa-trash') || target.is('.edit') ) {

            e.preventDefault();
            var $this = $(this);
            var row = $this.closest('tr');
            var id = row.data('id');

            if( target.is(".status-column") || target.is(".status-column span") ){
                var action = 'handle_check_affiliate_link';
                row.find('.status-spinner').show();
                row.find('.product-status').hide();
                row.find('.last-checked').hide();
            }else{
                var action = 'handle_render_affiliate_edit_template';
            }

            var data = {
                '_wpnonce' : row.data('nonce'),
                'action': action,
                'id': id
            };

            $.ajax(ajaxurl, {
                data: data,
                method: 'get',
                dataType: 'json',
                success: function(data) {

                    // console.log( data );
                    if(data.success == true) {
                        
                        if( target.is(".status-column") || target.is(".status-column span") ){

                            console.log( data.link_checker );

                            row.find('.status-spinner').hide();
                            row.find('.product-status').show();
                            row.find('.last-checked').show();

                            console.log( row.find('.status-column .product-status') );

                            if( row.find('.status-column .product-status') != undefined && data.link_checker != undefined ){
                                row.find('.status-column .product-status').removeClass("in-stock");
                                row.find('.status-column .product-status').removeClass("api-error");
                                row.find('.status-column .product-status').removeClass("out-of-stock");
                                row.find('.status-column .product-status').removeClass("four-oh-four");
                                row.find('.status-column .product-status').removeClass("created");
                                row.find('.status-column .product-status').removeClass("not-alllowed");
                                row.find('.status-column .product-status').html( format_capitalize(data.link_checker.status) ).addClass(data.link_checker.status);
                                row.find('.last-checked').html( 'Checked today' );

                                if( data.link_checker.status == "api-error" && data.link_checker.message != undefined ){
                                    alert( data.link_checker.message );
                                }
                            }

                        }else{
                            $(".affiliate-item-row-add").html(data.template).modal('show');
                        }

                    } else {
                        var errors = [];
                        $.each(data.errors, function(k,v) {
                            errors.push(v);
                        });
                        $('.notice-error-ajax').html('<p>' + errors.join('<br>') + '</p>').removeClass('notice-success').addClass('notice-error').show();
                    }
                },
                fail: function(data) {
                    $('.notice-error-ajax').html('<p>There was a problem loading the affiliate.</p>').removeClass('notice-success').addClass('notice-error').show();
                }
            });
        }

    });


    /**
     *
     */
    $('body').on('click', '.row-edit .save', function(e) {
        e.preventDefault();
        var $this = $(this);
        var row = $this.closest('.row-edit');
        var id = row.data('id');

        var label = row.find('[name="label"]');
        var url = row.find('[name="url"]');
        var text = row.find('[name="text"]');

        var errors = [];

        if(label.val() == '') {
            errors.push('Label is required.');
            label.addClass('has-error');
        } else {
            label.removeClass('has-error');
        }

        if(url.val() == '') {
            errors.push('Product URL is required.');
            url.addClass('has-error');
        } else {
            url.removeClass('has-error');
        }

        if(errors.length) {
            $('.notice-error-ajax').html('<p>' + errors.join('<br>') + '</p>').removeClass('notice-success').addClass('notice-error').show();
            return false;
        }

        $('.notice-error-ajax').hide();
        $(row).addClass('loading');

        var data = {
            '_wpnonce' : row.data('nonce'),
            'action': 'handle_post_affiliate_edit',
            'id': id,
            'label' : label.val(),
            'url' : url.val(),
            'text' : text.val()
        };

        $.ajax(ajaxurl, {
            data: data,
            method: 'post',
            dataType: 'json',
            success: function(data) {
                $(row).removeClass('loading');
                if(data.success == true) {
                    show_notice('Settings have been saved', 'success', 'show');
                    location.reload();
                } else {
                    $.each(data.errors, function(k,v) {
                        row.find('[name="' + k + '"]').addClass('has-error');
                        errors.push(v);
                    });
                    $('.notice-error-ajax').html('<p>' + errors.join('<br>') + '</p>').addClass('notice-success').removeClass('notice-error').show();
                }
            },
            fail: function(data) {
                $('.notice-error-ajax').html('<p>There was a problem editing the affiliate.</p>').removeClass('notice-success').addClass('notice-error').show();
            }
        });
    });


    /**
     *
     */
    $('.clocks-header .refer-button.preview').click(function(e){
		
        var row = $(".row-edit");
        var id = $(row).data('id');

        if( id != undefined){
            var $button = $(this);
            var icon = $button.find('.icon');
            icon.addClass('hidden').after('<i class="fa fa-spinner fa-spin"></i>');

            var displayTimer = row.find('[name="display_timer"]');
            var clockName = row.find('[name="clock_name"]');
            var productName = row.find('[name="product_name"]');
            var product_description = row.find('[name="product_description"]');
            var url = row.find('[name="purchase_link"]');
            var callToAction = row.find('[name="call_to_action"]');
            var buttonLabel = row.find('[name="button_label"]');
            var context_button_label = row.find('[name="context_button_label"]');
            var full_price_label = row.find('[name="full_price_label"]');
            var image = row.find('[name="product_image_id"]');
            var countdown_ends = row.find('[name="countdown_ends"]');
            var startDate = row.find('[name="start_date"]');
            var startTime = row.find('[name="start_time"]');
            var endDate = row.find('[name="end_date"]');
            var endTime = row.find('[name="end_time"]');
            var relative_time = row.find('[name="relative_time"]');
            var location_header_home = row.find('[name="location_header_home"]');
            var location_header_pages = row.find('[name="location_header_pages"]');
            var location_post_top = row.find('[name="location_post_top"]');
            var posts = get_multi_vals( row.find('select[name="posts[]"]') );
            var pages = get_multi_vals( row.find('select[name="pages[]"]') );
            var cats = get_multi_vals( row.find('select[name="cats[]"]') );
            var background_color = row.find('[name="background_color"]');
            var text_color= row.find('[name="text_color"]');
            var button_color= row.find('[name="button_color"]');
            var button_text_color= row.find('[name="button_text_color"]');            
            var header_background_color = row.find('[name="header_background_color"]');
            var header_text_color= row.find('[name="header_text_color"]');
            var header_button_color= row.find('[name="header_button_color"]');
            var header_button_text_color= row.find('[name="header_button_text_color"]');


            var errors = [];

            if(productName.val() == '') {
                errors.push('Label is required.');
                productName.addClass('has-error');
            } else {
                productName.removeClass('has-error');
            }

            if(url.val() == '') {
                errors.push('Product Link is required.');
                url.addClass('has-error');
            } else {
                url.removeClass('has-error');
            }

            if(callToAction.val() == '') {
                errors.push('Call to Action is required')
                callToAction.addClass('has-error')
            } else {
                callToAction.removeClass('has-error')
            }

            if(buttonLabel.val() == '') {
                errors.push('Button Label is required')
                buttonLabel.addClass('has-error')
            } else {
                buttonLabel.removeClass('has-error')
            }

            if(endDate.val() == '') {
                errors.push('End Date is required')
                endDate.addClass('has-error')
            } else {
                endDate.removeClass('has-error')
            }

            if(errors.length) {
                $('.notice-error-ajax').html('<p>' + errors.join('<br>') + '</p>').removeClass('notice-success').addClass('notice-error').show();
                return false;
            }

            $('.notice-error-ajax').hide();
            
            var data = {
                'action': 'handle_render_countdown_preview_modal_template',
                'id': id,
                'display_timer' : displayTimer.val(),
                'clock_name' : clockName.val(),
                'product_name' : productName.val(),
                'product_description' : product_description.val(),
                'purchase_link' : url.val(),
                'call_to_action' : callToAction.val(),
                'button_label' : buttonLabel.val(),
                'context_button_label' : context_button_label.val(),
                'full_price_label' : full_price_label.val(),
                'product_image_id' : image.val(),
                'countdown_ends' : countdown_ends.val(),
                'start_date' : startDate.val(),
                'start_time' : startTime.val(),
                'end_date' : endDate.val(),
                'end_time' : endTime.val(),
                'relative_time' : relative_time.val(),
                'location_header_home' : location_header_home.val(),
                'location_header_pages' : location_header_pages.val(),
                'location_post_top' : location_post_top.val(),
                'posts' : posts,
                'pages' : pages,
                'cats' : cats,
                'background_color' : background_color.val(),
                'text_color' : text_color.val(),
                'button_color' : button_color.val(),
                'button_text_color' : button_text_color.val(),
                'header_background_color' : header_background_color.val(),
                'header_text_color' : header_text_color.val(),
                'header_button_color' : header_button_color.val(),
                'header_button_text_color' : header_button_text_color.val(),
            };

            $.ajax(ajaxurl, {
                data: data,
                method: 'get',
                dataType: 'json',
                success: function(data) {
                    icon.removeClass('hidden');
                    $button.find('i').remove();
                    if(data.success == true) {

						$(document).on('show.bs.modal','#clock-preview-modal', function () {
							//init flipdowns if exist
							//console.log('modal shown');
							if( $('.refer-cd-wrap').length > 0 ){
								//console.log('refer-cd-wrap');
								
								//remove any rotators left from previous preview
								$('.rotor-group').remove();
								$.each( $('.refer-cd-wrap'), function(i, element){
									
									if( !$(element).find('.refer-cd-flipdown').length > 0 ){
										console.log('appended');
										$(element).empty().append('<div class="refer-cd-flipdown flipdown" id="flipdown_' + $(element).data('rnd') + '"></div>');
									}

									flipdowns[ $(element).data('rnd') ] = new FlipDown( 
										$(element).data('uts'), 
										"flipdown_" + $(element).data('rnd'),
										{ theme: "custom_" + $(element).data('rnd') } 
									).start();

								});
								//console.log(flipdowns);
							}
						});
						$(document).on('hide.bs.modal','#clock-preview-modal', function () {
							//console.log(data);
							//destroy all flipdowns in preview
							if( $('.refer-cd-wrap').length > 0 ){
								$.each( $('.refer-cd-wrap'), function(i, element){
									if( $(element).find('.refer-cd-flipdown').length > 0 ){
										clearInterval(flipdowns[$(element).data('rnd')].countdown);
										flipdowns[ $(element).data('rnd') ] = false;
										$(element).find('.refer-cd-flipdown').remove();
										//$('#flipdown_' + $(element).data('rnd') + ' .rotor-group').remove();
									}
								});
								
							}
							//$('.rotor-group').remove();
							//flipdowns.length = 0;
						});
                        $('#clock-preview-modal').addClass('preview').html(data.template).modal('show');
						/*$(".modal-affiliate-link-refer").addClass('preview').html(data.template).dialog({
                            title: 'Preview',
                            dialogClass: 'wp-dialog',
                            autoOpen: false,
                            draggable: false,
                            width: "90%",
                            maxWidth: "768px",
                            modal: true,
                            resizable: false,
                            fluid: true, //new option
                            closeOnEscape: true,
                            position: {
                              my: "center",
                              at: "center",
                              of: window
                            },
                            create: function () {
                                $('.ui-dialog-titlebar-close').addClass('ui-button');
                                //init flipdowns if exist
                                if( $('.refer-cd-wrap').length > 0 ){
                                    $.each( $('.refer-cd-wrap'), function(i, element){

                                        if( !$(element).find('.refer-cd-flipdown').length > 0 ){
                                            console.log("appended");
                                            $(element).append('<div class="refer-cd-flipdown flipdown" id="flipdown_' + $(element).data('rnd') + '"></div>');
                                        }

                                        flipdowns[ $(element).data('rnd') ] = new FlipDown( 
                                            $(element).data('uts'), 
                                            "flipdown_" + $(element).data('rnd'),
                                            { theme: "custom_" + $(element).data('rnd') } 
                                        ).start();
                                        
                                    });
                                }
                            },
                            close: function() {
                                //destroy all flipdowns in preview
                                if( $('.refer-cd-wrap').length > 0 ){
                                    $.each( $('.refer-cd-wrap'), function(i, element){
                                        if( $(element).find('.refer-cd-flipdown').length > 0 ){
                                            clearInterval(flipdowns[$(element).data('rnd')].countdown);
                                            flipdowns[ $(element).data('rnd') ] = false;
                                            console.log('removing' + $(element).find('.refer-cd-flipdown') );
                                            $(element).find('.refer-cd-flipdown').remove();
                                        }
                                    });
                                }
                            }
                        }).removeClass('hidden').dialog('open');*/
                    } else {
                        var errors = [];
                        $.each(data.errors, function(k,v) {
                            row.find('[name="' + k + '"]').addClass('has-error');
                            errors.push(v);
                        });
                        $('.notice-error-ajax').html('<p>' + errors.join('<br>') + '</p>').removeClass('notice-success').addClass('notice-error').show();
                    }
                },
                fail: function(data) {
                    icon.removeClass('hidden');
                    $button.find('i.fa').remove();
                    $('.notice-error-ajax').html('<p>There was a problem loading the preview.</p>').removeClass('notice-success').addClass('notice-error').show();
                }
            });

        }
    });

    /**
     *
     */
    $('body').on('click', '.affiliates-edit .row-view .delete', function(e) {
        
        // console.log('affiliate-delete');
           
        e.preventDefault();
        var $this = $(this);
        var row = $this.closest('tr');
        var icon = $this.find('i');
        var id = row.data('id');

        icon.prop('class', 'fa fa-spinner fa-spin');

        var data = {
            '_wpnonce' : $this.data('nonce'),
            'action': 'handle_render_affiliate_delete_modal_template',
            'id': id
        };

        $.ajax(ajaxurl, {
            data: data,
            method: 'get',
            dataType: 'json',
            success: function(data) {

                // console.log(data);

                icon.prop('class', 'fa fa-trash');
                if(data.success == true) {
                    $(".affiliate-item-row-add").html(data.template).modal('show');
					/*$(".affiliate-item-row-add").html(data.template).dialog({
                        title: 'Delete Affiliate?',
                        dialogClass: 'wp-dialog',
                        autoOpen: false,
                        draggable: false,
                        width: 'auto',
                        modal: true,
                        resizable: false,
                        fluid: true, //new option
                        closeOnEscape: true,
                        position: {
                          my: "center",
                          at: "center",
                          of: window
                        },
                        open: function () {
                            $('.ui-widget-overlay').bind('click', function(){
                                $(".affiliate-item-row-add").addClass('hidden').dialog('close');
                            })
                        },
                        create: function () {
                            $('.ui-dialog-titlebar-close').addClass('ui-button');
                        },
                    }).removeClass('hidden').dialog('open');*/
                } else {
                    var errors = [];
                    $.each(data.errors, function(k,v) {
                        row.find('[name="' + k + '"]').addClass('has-error');
                        errors.push(v);
                    });
                    $('.notice-error-ajax').html('<p>' + errors.join('<br>') + '</p>').removeClass('notice-success').addClass('notice-error').show();
                }
            },
            fail: function(data) {
                $('.notice-error-ajax').html('<p>There was a problem loading the affiliate.</p>').removeClass('notice-success').addClass('notice-error').show();
            }
        });

    });

    $('body').on('click', '.affiliate-delete .delete', function(e) {
        e.preventDefault();
        var $this = $(this);
        var row = $this.closest('.ui-dialog-content');
        var id = $this.data('id');

        var data = {
            '_wpnonce' : $this.data('nonce'),
            'action': 'handle_post_affiliate_delete',
            'id': id
        };

        $.ajax(ajaxurl, {
            data: data,
            method: 'post',
            dataType: 'json',
            success: function(data) {
                $(".affiliate-item-row-add").modal('hide');
				//$('#modal').dialog('close');
                if(data.success == true) {
                    $('.affiliates-edit').find('tr[data-id="' + id + '"]').remove();
                } else {
                    var errors = [];
                    $.each(data.errors, function(k,v) {
                        row.find('[name="' + k + '"]').addClass('has-error');
                        errors.push(v);
                    });
                    $('.notice-error-ajax').html('<p>' + errors.join('<br>') + '</p>').removeClass('notice-success').addClass('notice-error').show();
                }
            },
            fail: function(data) {
                $('.notice-error-ajax').html('<p>There was a problem deleting the affiliate.</p>').removeClass('notice-success').addClass('notice-error').show();
            }
        });
    });


    //do cancel button in modal
    $('body').on('click', '.affiliate-delete .cancel', function(e) {
        e.preventDefault();
        $('#modal').dialog('close');
    });


    //do cancel button in add/edit modal
    $('body').on('click', '.affiliate-item-row-add .cancel', function(e) {
        e.preventDefault();
        $('#modal').dialog('close');
    });


    /****************************************************************************************
     **************************** Countdown Links manager (CLOCKS) ************************
     ****************************************************************************************/

    /**
     * Countdown row cache
     * @type {Object}
     */
    var editCountdownRowsCache = {};
    
    //handle page list visibility
    if( $('#clocks_top').length > 0){
        handle_show_hide( $('.countdowns-add'), ( $('input[name=location_header_pages]').val() == 'checked' ), 'div.select-pages' );
        $('.countdowns-edit, .countdowns-add').on('change', 'input[name=location_header_pages]', function(e) {
            var row = $(this).closest('tr, .fields');
            handle_show_hide( row, ( $(this).val() == 'checked' ), 'div.select-pages' );
        });
        
        //handle post list visibility
        handle_show_hide( $('.countdowns-add'), ( $('input[name=location_post_top]').val() == 'checked' ), 'div.select-posts' );
        handle_show_hide( $('.countdowns-add'), ( $('input[name=location_post_top]').val() == 'checked' ), 'div.select-cats' );
        $('.countdowns-edit, .countdowns-add').on('change', 'input[name=location_post_top]', function(e) {
            var row = $(this).closest('tr, .fields');
            handle_show_hide( row, ( $(this).val() == 'checked' ), 'div.select-posts' );
            handle_show_hide( row, ( $(this).val() == 'checked' ), 'div.select-cats' );
        });

        handle_show_hide( $('#clocks_top'), ( $('select[name="posts[]"]').val().includes('all') ), 'div.select-cats' );
        $('#clocks_top').on('change', 'select[name="posts[]"]', function(e) {
            var row = $(this).closest('tr, .fields');
            handle_show_hide( row, ( $(this).val().includes('all') ), 'div.select-cats' );
        });

        handle_show_hide( $('#clocks_top'), ( $('select[name="cats[]"]').val().includes('all') ), 'div.select-posts' );
        $('#clocks_top').on('change', 'select[name="cats[]"]', function(e) {
            var row = $(this).closest('tr, .fields');
            handle_show_hide( row, ( $(this).val().includes('all') ), 'div.select-posts' );
        });
    }


    //shows (or hides) an element within a given row, based on the boolean (show)
    function handle_show_hide( row, show, target){

        if( show ){
            $(row).find(target).removeClass('hidden');
        }else{
            $(row).find(target).addClass('hidden');
        }
    }

    /**
     *
     */
    $('.countdowns-edit, .countdowns-add').on('change', 'select[name="countdown_ends"]', function(e) {
        // console.log( $(this).val() );
        var row = $(this).closest('tr, .fields');
        countdown_ends_visibilty(row);
    });

    /**
     *
     */
    $('.countdowns-edit, .countdowns-add').on('change', 'input[type="checkbox"]', function(e) {
        // console.log( $(this).val() );
        var label = $(this).closest('label');
        var input = $(label).find('input[type="hidden"]');

        if( $(this)[0].checked){
            $(input).val('checked').trigger('change');
        }else{
            $(input).val('not_checked').trigger('change');
        }
    });


    $('.countdowns-edit, .countdowns-add, .clocks-header').on('click', '.save, .create-clock', function(e) {

        console.log('add-save');
        $(this).addClass('loading');
        
        e.preventDefault();
        var $this = $(this);
        //var row = $this.closest('tr, .fields');
        var row = $('#clocks_top .fields');

        var displayTimer = row.find('[name="display_timer"]');
        var clockName = row.find('[name="clock_name"]');
        var productName = row.find('[name="product_name"]');
        var product_description = row.find('[name="product_description"]');
        var url = row.find('[name="purchase_link"]');
        var callToAction = row.find('[name="call_to_action"]');
        var buttonLabel = row.find('[name="button_label"]');
        var context_button_label = row.find('[name="context_button_label"]');
        var full_price_label = row.find('[name="full_price_label"]');
        var image = row.find('[name="product_image_id"]');
        var countdown_ends = row.find('[name="countdown_ends"]');
        var startDate = row.find('[name="start_date"]');
        var startTime = row.find('[name="start_time"]');
        var endDate = row.find('[name="end_date"]');
        var endTime = row.find('[name="end_time"]');
        var relative_time = row.find('[name="relative_time"]');
        var location_header_home = row.find('[name="location_header_home"]');
        var location_header_pages = row.find('[name="location_header_pages"]');
        var location_post_top = row.find('[name="location_post_top"]');
        var posts = get_multi_vals( row.find('select[name="posts[]"]') );
        var pages = get_multi_vals( row.find('select[name="pages[]"]') );
        var cats = get_multi_vals( row.find('select[name="cats[]"]') );
        var background_color =  row.find('[name="background_color"]');
        var text_color=  row.find('[name="text_color"]');
        var button_color= row.find('[name="button_color"]');
        var button_text_color=  row.find('[name="button_text_color"]');        
        var header_background_color =  row.find('[name="header_background_color"]');
        var header_text_color=  row.find('[name="header_text_color"]');
        var header_button_color= row.find('[name="header_button_color"]');
        var header_button_text_color=  row.find('[name="header_button_text_color"]');

        var errors = [];

        if(productName.val() == '') {
            errors.push('Product Name is required.');
            productName.addClass('has-error');
        } else {
            productName.removeClass('has-error');
        }
		
        if(url.val() == '' ) {
 		console.log(url.val());
           errors.push('Product Link is required.');

            //if(url.val() == '')
                url.addClass('has-error');

        } else {
            url.removeClass('has-error');
        }

        if (callToAction.val() === '') {
            errors.push("Call to action is required");
            callToAction.addClass('has-error');
        } else {
            callToAction.removeClass('has-error');
        }

        if (buttonLabel.val() == '') {
            errors.push("Button Text is required");
            buttonLabel.addClass('has-error');
        } else {
            buttonLabel.removeClass('has-error');
        }

        if (endDate.val() == '') {
            errors.push("End Date is required");
            endDate.addClass("has-error");
        } else {
            endDate.removeClass('has-error');
        }

        if(errors.length) {
            $('.notice-error-ajax').html('<p>' + errors.join('<br>') + '</p>').removeClass('notice-success').addClass('notice-error').show();
            return false;
        }

        $('.notice-error-ajax').hide();

        row.addClass('loading');

        var data = {
            '_wpnonce' : row.data('nonce'),
            'action': 'handle_post_refer_post_countdown_add',
            'clock_name' : clockName.val(),
            'display_timer' : displayTimer.val(),
            'product_name' : productName.val(),
            'product_description' : product_description.val(),
            'purchase_link' : url.val(),
            'call_to_action' : callToAction.val(),
            'button_label' : buttonLabel.val(),
            'context_button_label' : context_button_label.val(),
            'full_price_label' : full_price_label.val(),
            'countdown_ends' : countdown_ends.val(),
            'start_date' : startDate.val(),
            'start_time' : startTime.val(),
            'end_date' : endDate.val(),
            'end_time' : endTime.val(),
            'relative_time' : relative_time.val(),
            'product_image_id' : image.val(),
            'location_header_home' : location_header_home.val(),
            'location_header_pages' : location_header_pages.val(),
            'location_post_top' : location_post_top.val(),
            'posts' : posts,
            'pages' : pages,
            'cats' : cats,
            'background_color' : background_color.val(),
            'text_color' : text_color.val(),
            'button_color' : button_color.val(),
            'button_text_color' : button_text_color.val(),
            'header_background_color' : header_background_color.val(),
            'header_text_color' : header_text_color.val(),
            'header_button_color' : header_button_color.val(),
            'header_button_text_color' : header_button_text_color.val(),
        };

        console.log( data );

        $.ajax(ajaxurl, {
            data: data,
            method: 'post',
            dataType: 'json',
            success: function(data) {
                row.removeClass('loading');
                // console.log(data);
                if(data.success == true) {
                    row.replaceWith(data.template);
                    handle_color_pickers();
                    handle_show_hide( $('.countdowns-add'), ( $('input[name=location_header_pages]').val() == 'checked' ), 'div.select-pages' );
                    handle_show_hide( $('.countdowns-add'), ( $('input[name=location_post_top]').val() == 'checked' ), 'div.select-posts' );
                    handle_show_hide( $('.countdowns-add'), ( $('input[name=location_post_top]').val() == 'checked' ), 'div.select-cats' );
                    handle_show_hide( $('#clocks_top'), ( $('select[name="posts[]"]').val().includes('all') ), 'div.select-cats' );
                    handle_show_hide( $('#clocks_top'), ( $('select[name="cats[]"]').val().includes('all') ), 'div.select-posts' );

                    countdown_ends_visibilty($(this));
                    handle_tooltips();
                    $(this).removeClass('loading');
                    // scrollto($("#clocks_bottom"));
                    show_notice('Settings have been saved', 'success', 'show');
                    $(".refer-header .create").addClass('hidden');
                    $(".refer-header .cancel, .refer-header .save, .refer-header .preview").removeClass('hidden');
                    refresh_clocks_list();                   

                } else {
                    $.each(data.errors, function(k,v) {
                        row.find('[name="' + k + '"]').addClass('has-error');
                        errors.push(v);
                    });
                    $('.notice-error-ajax').html('<p>' + errors.join('<br>') + '</p>').removeClass('notice-success').addClass('notice-error').show();
                }
            },
            fail: function(data) {
                console.log(data);
                row.removeClass('loading');
                $('.notice-error-ajax').html('<p>There was a problem adding the countdown item.</p>').removeClass('notice-success').addClass('notice-error').show();
            }
        });
    });

    /**
     *
     */
    $('#clocks_bottom').on('click', '.row-view', function(e) {

        var target  = $(e.target);

        if( !target.is('a') || target.is('.edit') ) {

            e.preventDefault();

            $("#clocks_top .row-add, #clocks_top .row-edit").addClass('loading');
            scrollto($("#clocks_top"));

            var $this = $(this);
            var row = $this.closest('tr');
            var id = row.data('id');


            var data = {
                '_wpnonce' : row.data('nonce'),
                'action': 'handle_render_countdown_edit_template',
                'id': id
            };

            $.ajax(ajaxurl, {
                data: data,
                method: 'get',
                dataType: 'json',
                success: function(data) {
                    if(data.success == true) {
                        editCountdownRowsCache[id] = row;
                        $("#clocks_top").html(data.template);
                        $("#clocks_top .row-add, #clocks_top .row-edit").removeClass('loading');
                        $(".refer-header .create").addClass('hidden');
                        $(".refer-header .cancel, .refer-header .save, .refer-header .preview").removeClass('hidden');
                        $('.countdowns-edit .row-view.active').removeClass("active");
                        $(row).addClass("active");
                        handle_color_pickers();
                        handle_show_hide( $('.countdowns-add'), ( $('input[name=location_header_pages]').val() == 'checked' ), 'div.select-pages' );
                        handle_show_hide( $('.countdowns-add'), ( $('input[name=location_post_top]').val() == 'checked' ), 'div.select-posts' );
                        handle_show_hide( $('.countdowns-add'), ( $('input[name=location_post_top]').val() == 'checked' ), 'div.select-cats' );
                        handle_show_hide( $('#clocks_top'), ( $('select[name="posts[]"]').val().includes('all') ), 'div.select-cats' );
                        handle_show_hide( $('#clocks_top'), ( $('select[name="cats[]"]').val().includes('all') ), 'div.select-posts' );

                        countdown_ends_visibilty($("#clocks_top"));
                        handle_tooltips();
                    } else {
                        var errors = [];
                        $.each(data.errors, function(k,v) {
                            errors.push(v);
                        });
                        $('.notice-error-ajax').html('<p>' + errors.join('<br>') + '</p>').removeClass('notice-success').addClass('notice-error').show();
                    }
                },
                fail: function(data) {
                    $('.notice-error-ajax').html('<p>There was a problem loading the countdown item.</p>').removeClass('notice-success').addClass('notice-error').show();
                }
            });
        }

    });

    /**
     *
     */
    $('.countdowns-add').on('click', '.row-edit .save', function(e) {

        // console.log('edit-save');

        e.preventDefault();
        var $this = $(this);
        var row = $this.closest('tr, .row-edit.row');
        var icon = $this.find('i');
        var id = row.data('id');

        $(row).addClass('loading');

        var displayTimer = row.find('[name="display_timer"]');
        var clockName = row.find('[name="clock_name"]');
        var productName = row.find('[name="product_name"]');
        var product_description = row.find('[name="product_description"]');
        var url = row.find('[name="purchase_link"]');
        var callToAction = row.find('[name="call_to_action"]');
        var buttonLabel = row.find('[name="button_label"]');
        var context_button_label = row.find('[name="context_button_label"]');
        var full_price_label = row.find('[name="full_price_label"]');
        var image = row.find('[name="product_image_id"]');
        var countdown_ends = row.find('[name="countdown_ends"]');
        var startDate = row.find('[name="start_date"]');
        var startTime = row.find('[name="start_time"]');
        var endDate = row.find('[name="end_date"]');
        var endTime = row.find('[name="end_time"]');
        var relative_time = row.find('[name="relative_time"]');
        var location_header_home = row.find('[name="location_header_home"]');
        var location_header_pages = row.find('[name="location_header_pages"]');
        var location_post_top = row.find('[name="location_post_top"]');
        var posts = get_multi_vals( row.find('select[name="posts[]"]') );
        var pages = get_multi_vals( row.find('select[name="pages[]"]') );
        var cats = get_multi_vals( row.find('select[name="cats[]"]') );
        var background_color = row.find('[name="background_color"]');
        var text_color= row.find('[name="text_color"]');
        var button_color= row.find('[name="button_color"]');
        var button_text_color= row.find('[name="button_text_color"]');      
        var header_background_color = row.find('[name="header_background_color"]');
        var header_text_color= row.find('[name="header_text_color"]');
        var header_button_color= row.find('[name="header_button_color"]');
        var header_button_text_color= row.find('[name="header_button_text_color"]');


        var errors = [];

        if(productName.val() == '') {
            errors.push('Label is required.');
            productName.addClass('has-error');
        } else {
            productName.removeClass('has-error');
        }

        if(url.val() == '') {
            errors.push('Product Link is required.');
            url.addClass('has-error');
        } else {
            url.removeClass('has-error');
        }

        if(callToAction.val() == '') {
            errors.push('Call to Action is required')
            callToAction.addClass('has-error')
        } else {
            callToAction.removeClass('has-error')
        }

        if(buttonLabel.val() == '') {
            errors.push('Button Label is required')
            buttonLabel.addClass('has-error')
        } else {
            buttonLabel.removeClass('has-error')
        }

        if(endDate.val() == '') {
            errors.push('End Date is required')
            endDate.addClass('has-error')
        } else {
            endDate.removeClass('has-error')
        }

        if(errors.length) {
            $('.notice-error-ajax').html('<p>' + errors.join('<br>') + '</p>').removeClass('notice-success').addClass('notice-error').show();
            return false;
        }

        $('.notice-error-ajax').hide();
        
        var data = {
            '_wpnonce' : row.data('nonce'),
            'action': 'handle_post_refer_countdown_edit',
            'id': id,
            'display_timer' : displayTimer.val(),
            'clock_name' : clockName.val(),
            'product_name' : productName.val(),
            'product_description' : product_description.val(),
            'purchase_link' : url.val(),
            'call_to_action' : callToAction.val(),
            'button_label' : buttonLabel.val(),
            'context_button_label' : context_button_label.val(),
            'full_price_label' : full_price_label.val(),
            'product_image_id' : image.val(),
            'countdown_ends' : countdown_ends.val(),
            'start_date' : startDate.val(),
            'start_time' : startTime.val(),
            'end_date' : endDate.val(),
            'end_time' : endTime.val(),
            'relative_time' : relative_time.val(),
            'location_header_home' : location_header_home.val(),
            'location_header_pages' : location_header_pages.val(),
            'location_post_top' : location_post_top.val(),
            'posts' : posts,
            'pages' : pages,
            'cats' : cats,
            'background_color' : background_color.val(),
            'text_color' : text_color.val(),
            'button_color' : button_color.val(),
            'button_text_color' : button_text_color.val(),
            'header_background_color' : header_background_color.val(),
            'header_text_color' : header_text_color.val(),
            'header_button_color' : header_button_color.val(),
            'header_button_text_color' : header_button_text_color.val(),
        };

        // console.log(data);

        $.ajax(ajaxurl, {
            data: data,
            method: 'post',
            dataType: 'json',
            success: function(data) {
                // console.log(data);
                $(row).removeClass('loading');
                if(data.success == true) {

                    $("#clocks_top").html(data.template);
                    handle_color_pickers();
                    handle_show_hide( $('.countdowns-add'), ( $('input[name=location_header_pages]').val() == 'checked' ), 'div.select-pages' );
                    handle_show_hide( $('.countdowns-add'), ( $('input[name=location_post_top]').val() == 'checked' ), 'div.select-posts' );
                    handle_show_hide( $('.countdowns-add'), ( $('input[name=location_post_top]').val() == 'checked' ), 'div.select-cats' );
                    handle_show_hide( $('#clocks_top'), ( $('select[name="posts[]"]').val().includes('all') ), 'div.select-cats' );
                    handle_show_hide( $('#clocks_top'), ( $('select[name="cats[]"]').val().includes('all') ), 'div.select-posts' );
                    countdown_ends_visibilty($("#clocks_top"));
                    handle_tooltips();
                    refresh_clocks_list();
                    show_notice('Settings have been saved', 'success', 'show');
                    // location.reload();

                } else {
                    $.each(data.errors, function(k,v) {
                        row.find('[name="' + k + '"]').addClass('has-error');
                        errors.push(v);
                    });
                    $('.notice-error-ajax').html('<p>' + errors.join('<br>') + '</p>').removeClass('notice-success').addClass('notice-error').show();
                }
            },
            fail: function(data) {
                console.log(data);
                $(row).removeClass('loading');
                $('.notice-error-ajax').html('<p>There was a problem editing the countdown item.</p>').removeClass('notice-success').addClass('notice-error').show();
            }
        });
    });

    /**
     *
     */
    $('.countdowns-edit, .countdowns-add').on('click', '.row-edit .cancel', function(e) {

        console.log('edit-cancel');

        e.preventDefault();
        var $this = $(this);
        var row = $(".row-edit")
        $('.notice-error-ajax').hide();

        $(row).addClass('loading');

        var data = {
            '_wpnonce' : $(row).data('nonce'),
            'action': 'handle_render_countdown_add_template',
        }

        $.ajax(ajaxurl, {
            data: data,
            method: 'get',
            dataType: 'json',
            success: function(data) {
                
                if(data.success == true) {
                    $("#clocks_top").html(data.template);
                    $("#clocks_top .row-add, #clocks_top .row-edit").removeClass('loading');
                    $(".refer-header .create").removeClass('hidden');
                    $(".refer-header .cancel, .refer-header .save, .refer-header .preview").addClass('hidden');
                    $("#clocks_bottom .active").removeClass("active");

                }
            },
            fail: function(data) {
                $('.notice-error-ajax').html('<p>There was a problem.</p>').removeClass('notice-success').addClass('notice-error').show();
            }
        });

    });

    /**
     *
     */
    $('#clocks_bottom').on('click', '.row-view .delete', function(e) {

        console.log('modal delete');

        e.preventDefault();
        var $this = $(this);
        var row = $this.closest('tr');
        var icon = $this.find('i');
        var id = row.data('id');

        icon.prop('class', 'fa fa-spinner fa-spin');

        var data = {
            'action': 'handle_render_countdown_delete_modal_template',
            'id': id
        };

        $.ajax(ajaxurl, {
            data: data,
            method: 'get',
            dataType: 'json',
            success: function(data) {
                console.log(data);
                if(data.success == true) {

                    icon.prop('class', 'fa fa-trash');

                    $("#clock-delete-modal").html(data.template).modal('show');
					/*$('#modal').removeClass('hidden').html(data.template).dialog({
                        title: 'Delete Clock?',
                        dialogClass: 'wp-dialog',
                        autoOpen: false,
                        draggable: false,
                        width: 'auto',
                        modal: true,
                        resizable: false,
                        fluid: true, //new option
                        closeOnEscape: true,
                        position: {
                            my: "center",
                            at: "center",
                            of: window
                        },
                        open: function () {
                            $('.ui-widget-overlay').bind('click', function(){
                                $('#modal').dialog('close').addClass('hidden');
                            })
                        },
                        create: function () {
                            $('.ui-dialog-titlebar-close').addClass('ui-button');
                        },
                    }).dialog('open');*/
                } else {
                    var errors = [];
                    $.each(data.errors, function(k,v) {
                        row.find('[name="' + k + '"]').addClass('has-error');
                        errors.push(v);
                    });
                    $('.notice-error-ajax').html('<p>' + errors.join('<br>') + '</p>').removeClass('notice-success').addClass('notice-error').show();
                }
            },
            fail: function(data) {
                $('.notice-error-ajax').html('<p>There was a problem loading the countdown item.</p>').removeClass('notice-success').addClass('notice-error').show();
            }
        });
    });

    //do delete button in modal
    $('#clock-delete-modal').on('click', '.delete', function(e) {

        console.log('countdown-delete');

        e.preventDefault();
        var $this = $(this);
        //var row = $this.closest('tr');
        var id = $this.data('id');

        var data = {
            'id': id,
            '_wpnonce' : $this.data('nonce'),
            'action': 'handle_post_countdown_delete',
        };

        $.ajax(ajaxurl, {
            data: data,
            method: 'post',
            dataType: 'json',
            success: function(data) {
                $('#clock-delete-modal').modal('hide');
                if(data.success == true) {
                    $('.countdowns-edit').find('tr[data-id="' + id + '"]').remove();
                    show_notice('Successfully deleted', 'success', 'show');
                    //also reset main window if current row is active
                    if( $this.data('id') == $(".row-edit").data('id') && data.template != undefined){
                        $("#clocks_top").html(data.template);
                    }
                } else {
                    var errors = [];
                    $.each(data.errors, function(k,v) {
                        row.find('[name="' + k + '"]').addClass('has-error');
                        errors.push(v);
                    });
                    $('.notice-error-ajax').html('<p>' + errors.join('<br>') + '</p>').removeClass('notice-success').addClass('notice-error').show();
                }
            },
            fail: function(data) {
                $('.notice-error-ajax').html('<p>There was a problem deleting the countdown item.</p>').removeClass('notice-success').addClass('notice-error').show();
            }
        });
    });

    //do cancel button in modal
    $('body').on('click', '.countdown-delete .cancel', function(e) {
        e.preventDefault();
        $('#modal').dialog('close');
    });

    $('.countdowns-edit, .countdowns-add').on('click', ".product-image-add", function (e) {
        e.preventDefault();
        var $trigger = $(this).parents(".media-modal-trigger");
        var imageField = $trigger.siblings('input');
        var imagePlaceholder = $trigger.siblings('img');

        // Create the media frame.
        wpOpenGallery(null, function(data) {
            let imageId = data[0].id;

            if( data[0].sizes != undefined ){
                let thumb = data[0].sizes.thumbnail.url;
                imageField.val(imageId).change();
                $($trigger).css('background', 'url(' + thumb + ')');
                // imagePlaceholder.removeClass('countdown-product-image-placeholder');
                $($trigger).find('a.product-image-remove').removeClass('product-image-remove-hidden');
                $($trigger).find('a.product-image-add').addClass('product-image-add-hidden');
            }
        });
    });

    $('.countdowns-edit, .countdowns-add').on('click', ".product-image-remove", function (e) {
        e.preventDefault();
        var $trigger = $(this).parents(".media-modal-trigger");
        $trigger.siblings('input').val("");
        $trigger.siblings('img').remove();

        $($trigger).css('background', '');
        // imagePlaceholder.removeClass('countdown-product-image-placeholder');
        $($trigger).find('a.product-image-remove').addClass('product-image-remove-hidden');
        $($trigger).find('a.product-image-add').removeClass('product-image-add-hidden');
    });

    $('.countdowns-edit, .countdowns-add').on('click', ".product-image-remove", function (e) {
        e.preventDefault();
        var $trigger = $(this);
        var imageField = $(this).siblings('input');
        var imagePlaceholder = $(this).siblings('img');
        imageField.val('');
        imagePlaceholder.attr('src', "");
        imagePlaceholder.addClass('countdown-product-image-placeholder');
        $(this).siblings('a.media-modal-trigger').text('Select Product Image');
        $trigger.addClass('product-image-remove-hidden');
    });

    /* 
    * loads a list of clocks and replaces the table with ajax result
    */
    function refresh_clocks_list(){

        $("#clocks_bottom").addClass('loading');

        var data = {
            'action': 'handle_render_clocks_list',
        }

        //get search/sort params from URL
        let params = new URLSearchParams( location.search.substring(1) );

        if( params.get("sortCountdownByName") != null )
            data.sortCountdownByName = params.get("sortCountdownByName");

        if( params.get("sortCountdownByUrl") != null )
            data.sortCountdownByUrl = params.get("sortCountdownByUrl");

        if( params.get("sortCountdownByEndDate") != null )
            data.sortCountdownByEndDate = params.get("sortCountdownByEndDate");

        if( params.get("sortCountdownByViews") != null )
            data.sortCountdownByViews = params.get("sortCountdownByViews");

        if( params.get("sortCountdownByStatus") != null )
            data.sortCountdownByStatus = params.get("sortCountdownByStatus");

        if( params.get("sortCountdownByClicks") != null )
            data.sortCountdownByClicks = params.get("sortCountdownByClicks");

        $.ajax(ajaxurl, {
            data: data,
            method: 'get',
            dataType: 'json',
            success: function(data) {
                // console.log( data );
                if(data.success == true) {
                    $("#clocks_bottom").html(data.template);
                    $("#clocks_bottom").removeClass('loading');

                    //make current row active
                    if( $(".row-edit").data('id') != undefined ){
                        if( $(".row-edit").data('id') != '' ){
                            $(".row-view[data-id=" + $(".row-edit").data('id') + "]").addClass('active');
                        }
                    }
                }
            },
            fail: function(data) {
                $('.notice-error-ajax').html('<p>There was a problem.</p>').removeClass('notice-success').addClass('notice-error').show();
            }
        });
    }

    /**************************************************************************************
    ************************************* Shortcodes **************************************
    ***************************************************************************************/


    /**
     * Affiliate Link REFER shortcodes in gutenburg
     * @param  {[type]} wp [description]
     * @return {[type]}    [description]
     */
    (function(wp) {
        if(typeof wp.richText !== 'undefined') {

            /**
             * Add a modal wrapper
             */
            $('body').append('<div id="modal-refer-shortcode-manager" />');

            wp.richText.registerFormatType(
                'affiliate-link-refer/shortcodes', {
                    title: 'REFER Shortcodes',
                    tagName: 'refer',
                    className: null,
                    edit: function(props) {

                        return wp.element.createElement(wp.editor.RichTextToolbarButton, {
                            icon: 'shortcode',
                            title: 'REFER Shortcodes',
                            shortcutType: 'primary',
                            onClick: function() {
                                renderAffiliateLinkReferShortcodeModal(function(value) {
                                    props.onChange( wp.richText.insert(
                                        props.value,
                                        value
                                    ));
                                })
                            },
                        });
                    }
                }
            );
        }

        var renderAffiliateLinkReferShortcodeModal = function(insertShortcodeCallback)
        {
            var modal = $('#modal-refer-shortcode-manager');

            var data = {
                'action': 'handle_render_affiliate_insert_shortcode_modal_template',
            };

            $.ajax(ajaxurl, {
                data: data,
                method: 'get',
                dataType: 'json',
                success: function(data) {

                    modal.html(data.template).dialog({
                        title: 'Insert REFERafied Shortcode',
                        dialogClass: 'wp-dialog',
                        autoOpen: false,
                        draggable: false,
                        width: 'auto',
                        modal: true,
                        resizable: false,
                        fluid: true, //new option
                        closeOnEscape: true,
                        position: {
                          my: "center",
                          at: "center",
                          of: window
                        },
                        open: function () {
                            $('.ui-widget-overlay').bind('click', function(){
                                modal.dialog('close');
                            });

                            modal.on('click', '.affiliates-insert-shortcode .add', function() {
                                var $this = $(this);
                                var row = $this.closest('tr');
                                var shortcode = row.data('shortcode');
                                insertShortcodeCallback(shortcode);
                                modal.dialog('close');
                            });
                        },
                        create: function () {
                            $('.ui-dialog-titlebar-close').addClass('ui-button');
                        },
                    }).dialog('open');
                },
                fail: function(data) {
                    alert('There was a problem loading the affiliate shortcode modal.')
                }
            });
        }

        $('#modal-refer-shortcode-manager').submit('#formSearchAffiliateShortcode', function(e) {
            e.preventDefault();

            var $this = $(this);
            var wrapper = $('.affiliates-insert-shortcode');
            var modal = $('#modal-refer-shortcode-manager');
            var data = {
                'action': 'handle_render_affiliate_insert_shortcode_modal_template',
            };



            var search = $(this).find('[name="search"]')
            if(search.val() != '') {
                data['search'] = search.val();
            }

            wrapper.addClass('loading');

            $.ajax(ajaxurl, {
                data: data,
                method: 'get',
                dataType: 'json',
                success: function(data) {
                    modal.html(data.template)
                }
            });
        });

        $('#modal-refer-shortcode-manager').on('click', '.clear-search', function(e) {
            e.preventDefault();

            var $this = $(this);
            var form = $('#formSearchAffiliateShortcode');
            var search = form.find('[name="search"]');

            search.val('');
            form.trigger('submit');
        });


        $('#modal-refer-shortcode-manager').on('click', '.navigation a', function(e) {
            e.preventDefault();

            var $this = $(this);
            var wrapper = $('.affiliates-insert-shortcode');
            var modal = $('#modal-refer-shortcode-manager');
            var data = {
                'action': 'handle_render_affiliate_insert_shortcode_modal_template',
            };

            var search = modal.find('[name="search"]')
            if(search.val() != '') {
                data['search'] = search.val();
            }

            data['paged'] = $this.data('page-number');


            wrapper.addClass('loading');

            $.ajax(ajaxurl, {
                data: data,
                method: 'get',
                dataType: 'json',
                success: function(data) {
                    modal.html(data.template)
                }
            });
        });

    })(window.wp);


    $('body').on('click', '.amazon-shortlink-verfiy-wrap .button-verify', function(e) {
        e.preventDefault();
        var $this = $(this);
        var icon = $this.find('i');
        var wrap = $('.amazon-shortlink-verfiy-wrap');

        icon.prop('class', 'fa fa-spinner fa-spin').show();

        var data = {
            '_wpnonce' : $this.data('nonce'),
            'action': 'handle_post_verify_amazon_shortlink_converter'
        };

        // console.log(data);

        $.ajax(ajaxurl, {
            data: data,
            method: 'post',
            dataType: 'json',
            success: function(data) {
                // console.log(data);
                wrap.replaceWith(data.template);
            },
            fail: function(data) {
                wrap.prepend('<div class="notice notice-error inline"><p>Sorry, the converter tool could not be verified at this time.</p></div>');
            }
        });
    });

    function scrollto(element, time){
        if( time == undefined)
            var time = 2000;

        $([document.documentElement, document.body]).animate({
                scrollTop: $(element).offset().top
            }, time);
    }

    const wpOpenGallery = function(o, callback) {
        const options = (typeof o === 'object') ? o : {};

        // Predefined settings
        const defaultOptions = {
            title: 'Select Media',
            fileType: 'image',
            multiple: false,
            currentValue: '',
        };

        const opt = { ...defaultOptions, ...options };

        let image_frame;

        if(image_frame){
            image_frame.open();
        }

        // Define image_frame as wp.media object
        image_frame = wp.media({
            title: opt.title,
            multiple : opt.multiple,
            library : {
                type : opt.fileType,
            }
        });

        image_frame.on('open',function() {
            // On open, get the id from the hidden input
            // and select the appropiate images in the media manager
            const selection =  image_frame.state().get('selection');
            const ids = opt.currentValue.split(',');

            ids.forEach(function(id) {
                const attachment = wp.media.attachment(id);
                attachment.fetch();
                selection.add( attachment ? [ attachment ] : [] );
            });
        });

        image_frame.on('close',function() {
            // On close, get selections and save to the hidden input
            // plus other AJAX stuff to refresh the image preview
            const selection =  image_frame.state().get('selection');
            const files = [];

            selection.each(function(attachment) {
                files.push({
                    id: attachment.attributes.id,
                    filename: attachment.attributes.filename,
                    url: attachment.attributes.url,
                    type: attachment.attributes.type,
                    subtype: attachment.attributes.subtype,
                    sizes: attachment.attributes.sizes,
                });
            });

            callback(files);
        });

        image_frame.open();
    };

    function show_notice(message, mode, show_hide){

        if( message != undefined){

            $this = $('.notice-error-ajax');

            if( mode == undefined)
                mode = 'error';

            if( show_hide == undefined) 
                show_hide = 'show';

            if( mode = 'success' ){
                $this.removeClass('notice-error');
                $this.addClass('notice-success');
            }else if( mode = 'error' ){
                $this.removeClass('notice-success');
                $this.addClass('notice-error');
            }else{
                $this.removeClass('notice-success');
                $this.removeClass('notice-error');
            }

            $this.html('<p>' + message + '</p>' );

            if( show_hide == 'show' ){
                $this.fadeIn();
            }else{
                $this.fadeOut();
            }
        }

    }

    function format_capitalize(string){

        string = string.replace('_', " ").replace('-', " ").toLowerCase();
        string = string[0].toUpperCase() + string.substring(1);

        return string;
    }

});
