jQuery(function($) {

	$(document).ready(function(){

		bind_menu();
		bind_search();
		bind_copy_link();
		disabled_links();
		bind_copy_content();
		//handle_affiliates_create_button();

		// For jQuery UI dialogs 
		//TY https://stackoverflow.com/questions/16471890/responsive-jquery-ui-dialog-and-a-fix-for-maxwidth-bug
		$(window).resize(function () {
		    fluidDialog();
		});

		// catch dialog if opened within a viewport smaller than the dialog width
		$(document).on("dialogopen", ".ui-dialog", function (event, ui) {
		    fluidDialog();
		});


		$('.refer-header .refer-button.create').click(function(e){
			e.preventDefault();
			$('.row-add .save').click();
		});

		$('.refer-header .refer-button.save').click(function(e){
			e.preventDefault();
			// console.log( $('.row-edit .save') );
			$('.row-edit .save').click();
		});

		$('.refer-header .refer-button.cancel').click(function(e){
			e.preventDefault();
			$('.row-edit .cancel').click();
		});

		handle_close_button_cookie( '.disclaimers' );

	});

	//searches container for close button and if so, sets cookie and fades out container on close
	function handle_close_button_cookie(container){

		var target = $(container).find(".close");

		$(target).click(function(e){
			console.log( $(target).data('cookie') );
			if( $(target).data('cookie') != undefined){

	            setCookie($(target).data('cookie'), 'true');
	            $(container).fadeOut();
			}
		});
	}

	function handle_affiliates_create_button(){
		//depricated

		$('#refer_links .refer-button.create').click(function(e){
			e.preventDefault();
			$(".affiliate-item-row-add").dialog({
                title: 'New Affiliate Link',
                dialogClass: 'wp-dialog',
                autoOpen: false,
                draggable: false,
                width: "auto",
                max_width: "768px",
                modal: true,
                fluid: true, //new option
                resizable: false,
                closeOnEscape: true,
                position: {
                  my: "center",
                  at: "center",
                  of: window
                },
                open: function () {
                    $('.ui-widget-overlay, .row-add .cancel').bind('click', function(){
                        $(".affiliate-item-row-add").addClass('hidden').dialog('close');
                    })
                },
                create: function () {
                    $('.ui-dialog-titlebar-close').addClass('ui-button');
                },
            }).removeClass('hidden').dialog('open');
		});
	}


	function fluidDialog() {
	    var $visible = $(".ui-dialog:visible");
	    // each open dialog
	    $visible.each(function () {
	        var $this = $(this);
	        var dialog = $this.find(".ui-dialog-content").data("ui-dialog");
	        // if fluid option == true
	        if (dialog.options.fluid) {
	            var wWidth = $(window).width();
	            // check window width against dialog width
	            if (wWidth < (parseInt(dialog.options.maxWidth) + 50))  {
	                // keep dialog from filling entire screen
	                $this.css("max-width", "90%");
	            } else {
	                // fix maxWidth bug
	                $this.css("max-width", dialog.options.maxWidth + "px");
	            }
	            //reposition dialog
	            dialog.option("position", dialog.options.position);
	        }
	    });
	}

	function disabled_links(){

		$("a.disabled").click(function(e){
			e.preventDefault();
			e.stopPropagation();
			return false;
		});
	}

	function bind_copy_content(){

		$('.countdowns-add').on('click', '.copy-content', function(e) {

			copyToClipboard( $(this).html() );
			alert( $(this).html() + " copied to clipboard" );
		});
	}

	function bind_copy_link(){

		if( $(".refer-table .copy-link").length > 0){

			$(".refer-table .copy-link").click( function(){

				copyToClipboard( $(this).data('href') );
				alert( $(this).data('href') + " copied to clipboard" );

			});
		}
	}

	function bind_menu(){	

		if( $("ul.refer-menu").length > 0 && $(".icon.hamburger").length > 0 ){

			$(".icon.hamburger").click(function(e){

				if( $("ul.refer-menu").is( '.expanded') ){
					$("ul.refer-menu").removeClass('expanded');
				}else{
					$("ul.refer-menu").addClass('expanded');
				}
			});
		}

		//TODO WHy was this here?
		// if( $("ul.refer-menu").length > 0 && $(".settings-wrap, .admin-wrap").length > 0 ){
		// 	$(".settings-wrap, .admin-wrap").hover(function(e){
		// 		$("ul.refer-menu").hide().removeClass('expanded');
		// 		setTimeout(function(){
		// 			$("ul.refer-menu").show();
		// 		}, 500);
		// 	});
		// }

	}

	function bind_search(){

		$.each( $(".table-search"), function(i, _this){

			var index = ($(_this).data('table_index') != undefined)? $(_this).data('table_index') : "0";
			var field = $(_this).find(".search-field");
			$(_this).find('.search-message, .icon').click( function(e){

				$(_this).find(".search-message").hide();
				$(field).fadeIn().select();
				$(_this).find(".refer-button.search").fadeIn();
			});

			$(field).on('keyup', function (e) {
			    if (e.key === 'Enter' || e.keyCode === 13) {
			        $(_this).find(".refer-button.search").trigger('click');
			    }
			});

			$(_this).find(".refer-button.search").click(function(){

				if( $(field).val() != undefined && $(field).val() != '' ){
					var search = window.location.search + (window.location.search ? "&" : "?") + "s" + index + "=" + $(field).val();
		        }else{
		        	var params = new URLSearchParams( window.location.search ); 
		        	params.delete("s" + index);
		        	var search = '?' + params.toString();
		        }
		        window.location.href = window.location.protocol + "//" + window.location.host + window.location.pathname + search;

			});
		});
	}

	// TY https://stackoverflow.com/questions/33855641/copy-output-of-a-javascript-variable-to-the-clipboard
	function copyToClipboard(text) {
	    var dummy = document.createElement("textarea");
	    // to avoid breaking orgain page when copying more words
	    // cant copy when adding below this code
	    // dummy.style.display = 'none'
	    document.body.appendChild(dummy);
	    //Be careful if you use texarea. setAttribute('value', value), which works with "input" does not work with "textarea". – Eduard
	    dummy.value = text;
	    dummy.select();
	    document.execCommand("copy");
	    document.body.removeChild(dummy);
	}

	function setCookie(cname, cvalue, exdays) {
		if(exdays == undefined){
			exdays = 2100;
		}
        var d = new Date();
        d.setTime(d.getTime() + (exdays*24*60*60*1000));
        var expires = "expires="+ d.toUTCString();
        document.cookie = cname + "=" + cvalue + ";" + expires + ";path=/;SameSite=Strict";
    }

    function getCookie(name) {
        // Split cookie string and get all individual name=value pairs in an array
        var cookieArr = document.cookie.split(";");
        
        // Loop through the array elements
        for(var i = 0; i < cookieArr.length; i++) {
            var cookiePair = cookieArr[i].split("=");
            if(name == cookiePair[0].trim()) {
                // Decode the cookie value and return
                return decodeURIComponent(cookiePair[1]);
            }
        }
        // Return false if not found
        return false;
    }
    
    $('#refer_notif_toggle').on('click', function(){
       $('.refer_notifications').slideToggle();
    });
    
    //income school notifications
    $(document).on('click', '.dismiss-refer-notice', function(e) {
        e.preventDefault();
        var $notice = $(this).parent();
        var dismiss = $notice.data('id');
        //alert(dismiss);
        $.ajax(
            ajaxurl,
            {
                type: 'POST',
                data: {
                    action: 'dismiss_refer_notice',
                    post_id: dismiss
                },
                complete: function(){
                    $notice.fadeTo( 100, 0, function() {
                        $notice.slideUp( 100, function() {
                            $notice.remove();
                        });
                    });
                    var count_span = $('.notification_count');
                    var count = count_span.text();
                    count = count - 1;
                    console.log(count);
                    if(count < 1) {
                        count_span.hide();
                    }else{
                        count_span.text(count);
                    }
                }
            }
        );
    });

    

});