jQuery(function($) {

$(document).ready(function(){
	init_tooltips();
	bind_dropdown();
});

function getParamByName(name, url = window.location.href) {
    name = name.replace(/[\[\]]/g, '\\$&');
    var regex = new RegExp('[?&]' + name + '(=([^&#]*)|&|#|$)'),
        results = regex.exec(url);
    if (!results) return null;
    if (!results[2]) return '';
    return decodeURIComponent(results[2].replace(/\+/g, ' '));
}
	
function handle_daterange_picker() {
    var start;
    var end = moment();
	var label = 'Last 30 Days';
	var range = getParamByName('period');
	if (!range) range= '30-Days';
	switch(range){
		case '30-Days':
			start = moment().subtract(29, 'days');
			label = 'Last ' + range.replace('-', ' ');
			break;
		case '30-Weeks':
			start = moment().subtract(29, 'weeks');
			label = 'Last ' + range.replace('-', ' ');
			break;
		case '30-Months':
			start = moment().subtract(29, 'months');
			label = 'Last ' + range.replace('-', ' ');
			break;
		default:
			var dates = range.split('-');
			label = range.replace('-', ' - ');
			start = moment(dates[0]);
			end = moment(dates[1]);
	}
	
	
	
	function set_label(label){
		$('span.daterange').html(label);
		$('.ranges li').removeClass('active');
	}

    function cb(start, end, label) {
		var search = window.location.search + (window.location.search ? "&" : "?");
        search += "period=";
		var slug;
        //window.location.href = window.location.protocol + "//" + window.location.host + window.location.pathname + search;

		if ( label == 'Custom Range' ) {
			var new_label = start.format('MMMM D, YYYY') + ' - ' + end.format('MMMM D, YYYY');
			slug = new_label.replace(' - ', '-');
			//$('span.daterangehidden').html(new_label);
			$('span.daterange').html(new_label);
			window.location.href = window.location.protocol + "//" + window.location.host + window.location.pathname + search + slug;
		}else{
			slug = label.replace('Last ', '');
			slug = slug.replace(' ', '-');
			//$('span.daterangehidden').html(start.format('MMMM D, YYYY') + ' - ' + end.format('MMMM D, YYYY'));
			$('span.daterange').html(label);
			window.location.href = window.location.protocol + "//" + window.location.host + window.location.pathname + search + slug;
		}
    }

    $('#reportrange').daterangepicker({
        startDate: start,
        endDate: end,
        ranges: {
           'Last 30 Days': [moment().subtract(29, 'days'), moment()],
           'Last 30 Weeks': [moment().subtract(29, 'weeks'), moment()],
           'Last 30 Months': [moment().subtract(29, 'months').startOf('month'), moment().subtract(1, 'month').endOf('month')]
        },
        opens: 'left',
        
    }, cb);
	
	//**TODO**//
	//force minimum of 7 days for custom date range
	//this is not a built-in function of daterangepicker
	
	//console.log(isCustomDate());
    //cb(start, end, label);
	set_label(label)
}
handle_daterange_picker();

function bind_dropdown(){

	$.each($(".period-dropdown"), function(i, _this){
		$(_this).change(function(){

			var search = window.location.search + (window.location.search ? "&" : "?");
            search += "period=" + $(_this).val();
            window.location.href = window.location.protocol + "//" + window.location.host + window.location.pathname + search;

		});
	});
}

function init_tooltips(){
    	
	$.each($(".bar"), function(i, _this){

    	if( $(_this).attr("data-value") == undefined || !$(_this).attr("data-value") ){
    		var value = '<span class="value">Not Set</span>';
    	}else{
    		var value = '<span class="value">' + numberWithCommas( parseInt($(_this).attr("data-value"))) + '</span>';
    	}

		var content = '<div class="tip chart-tip ' + $(_this).attr("data-tooltip-class") + '"><div class="dot"></div><div class="label">' + $(_this).attr("data-label") + '</div><span class="number">' + value + '</span>';

		content += '</div></div>';

		if($(_this).data('ui-tooltip') == undefined){

			$(_this).tooltip({

    			items : "[data-label], [data-value], [data-tooltip-class]",
    			content : content,
    			position : { 
    				my: "left-45 bottom-25", 
    				at: "center-2 top-1", 
    				collision: 'none',
    				// using: function( position, feedback ) {
	       //              $(this).css( position );
	       //              $(this).addClass( feedback.vertical );
	       //              $(this).addClass( feedback.horizontal );
	       //          },
				},
				hide: false
    		});

		}else{
			$(_this).tooltip("option", "content", content );
		}

	});
}


//thank you https://stackoverflow.com/questions/2901102/how-to-print-a-number-with-commas-as-thousands-separators-in-javascript
function numberWithCommas(x, prefix = "") {
	if( isNaN(x) )
		return false;

    return prefix + x.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ",");
}

});
