jQuery(function($) {
    $(document).ready(function(){

        /***********************************************************/
        /*************************** Links *************************/
        /************************************************************/

        var viewed = [];

        document.querySelectorAll("a").forEach(function(element) {

            if( element.getAttribute("href") ){

                var match = false;
                $.each( nonce_object.affiliate_links, function(_id, _affiliate){

                    if( element.getAttribute("href") == _affiliate.link || element.getAttribute("href") == _affiliate.link ){
                        match = _id;
                    }
                });

                if(match !== false ){

                    element.setAttribute('rel', 'nofollow');
                    element.setAttribute('target', '_blank');

                    var xhttp = new XMLHttpRequest();

                    viewed[match] = element.getAttribute("href");

                    //Update clicks
                    element.onclick = function(e) {

                        if( !$(e.target).is(".refer-cd-button") ){
                            // console.log('log affiliate click');
                            var params = "url=" + encodeURIComponent(element.getAttribute("href")) + "&postId=" + nonce_object.postId + "&nonce=" + nonce_object.nonce;
                            xhttp.open("POST", nonce_object.ajaxUrl, true);
                            xhttp.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
                            xhttp.send(params + '&action=affiliate_link_log_click');
                        }
                    };
                }
            }

        });

        console.log(viewed);

        //Update views
        if(viewed.length) {
            var xhttp = new XMLHttpRequest();
            var urls = viewed.join('&urls[]=');
            var params = "urls[]=" + urls + "&postId=" + nonce_object.postId + "&nonce=" + nonce_object.nonce;
            xhttp.open("POST", nonce_object.ajaxUrl, true);
            xhttp.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
            xhttp.send(params + '&action=amazon_link_log_view');
        }

        /***********************************************************/
        /*************************** Clocks *************************/
        /************************************************************/

        document.querySelectorAll(".refer-cd-wrap").forEach(function(element) {

            var xhttp = new XMLHttpRequest();
            var clock_id = element.getAttribute('data-id');

            //handle clock timer
            if( $(element).find('.refer-cd-flipdown-wrap').length > 0 ){

                new FlipDown( 
                    $(element).data('uts'), 
                    "flipdown_" + $(element).data('rnd'),
                    { theme: "custom_" + $(element).data('rnd') } 
                ).start();
            }

            //handle close cookie
            $(element).find(".refer-cd-close").click(function (event) {
                event.preventDefault();
                setCookie("refer-cd-" + $(element).data('id') + "-seen",true,1);
                $(".refer-cd-wrap").hide();
            });

            //Update clicks
            element.querySelector(".refer-cd-button-wrap .refer-cd-button").onclick = function(e) {

                e.preventDefault();
                e.stopPropagation();

                var data = {
                    'nonce' : nonce_object.nonce,
                    'action': 'countdown_log_click',
                    'clockId' : clock_id,
                    'postId' : nonce_object.postId,
                };

                $.ajax(nonce_object.ajaxUrl, {
                    data: data,
                    method: 'post',
                    dataType: 'json',
                    success: function(data) {
                        // console.log('log clock click');
                        window.open( $(e.target).attr('href'), '_blank' );
                        // window.location = $(e.target).attr('href');
                    },
                    fail: function(data) {
                        // console.log(data);
                    }
                });

            }
        });

    }); //end document ready

    function setCookie(cname, cvalue, exdays) {
        var d = new Date();
        d.setTime(d.getTime() + (exdays*24*60*60*1000));
        var expires = "expires="+ d.toUTCString();
        document.cookie = cname + "=" + cvalue + ";" + expires + ";path=/;SameSite=Strict";
    }


});
