<?php

namespace IncomeSchool\AffiliateLinkRefer;

class AffiliateShortlinkConverter
{
    
    private $amazon_api_key = 'AKIAJR24TYXSOAKLWOWQ';
    private $amazon_api_secret = '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';
    private $walmart_api_key = '699DEACE7E4A48D99299B9887855AC63';
    private $target_api_key = '9BB0587154FB4B1E97F0A4EBA7BCD546';


    /**
     * [__construct description]
     */
    public function __construct()
    {
        add_action('save_post', [$this, 'parsePostContentLinksOnSave'], 99, 3);
        add_action('widget_update_callback', [$this, 'parseWidgetContentLinksOnSave'], 99, 4);
        add_action('init', function() {
            if(!wp_next_scheduled( 'refer_check_affiliate_links_queue')) {
                wp_schedule_event( time(), 'refer_ten_min_interval', 'refer_check_affiliate_links_queue' );
            }
            if(!wp_next_scheduled( 'refer_amazon_short_link_converter_queue')) {
                wp_schedule_event( time(), 'refer_ten_min_interval', 'refer_amazon_short_link_converter_queue' );
            }
            if(!wp_next_scheduled( 'refer_amazon_short_link_old_page_checker')) {
                wp_schedule_event( time(), 'refer_one_hour_interval', 'refer_amazon_short_link_old_page_checker' );
            }
        });
        add_action('refer_check_affiliate_links_queue', [$this, 'check_affiliate_links'], 99);
        add_action('refer_amazon_short_link_converter_queue', [$this, 'processConverterQueue'], 99);
        add_action('refer_amazon_short_link_old_page_checker', [$this, 'queueOldPagesToConvert'], 99);

        //uncomment for testing
        // add_action( 'init', [$this, 'force_amazon_converter'] );
        // add_action( 'init', [$this, 'force_link_checker'] );

    }    

    public function force_link_checker(){
        // var_dump(get_option('refer_affiliate_link_index'));
        $this->check_affiliate_links();
    }

    public function force_amazon_converter(){
        // var_dump("Processing....");
        $this->processConverterQueue();
        $this->queueOldPagesToConvert();
    }

    /*Function to check affiliate links for out of stock or 404 status*/
    public function check_affiliate_links($id = NULL){

        global $wpdb;
        $status = false;
        $message = "";
        $tableName = $wpdb->prefix . "refer_affiliate_links";

        if( $id != NULL){

            $affiliate = $wpdb->get_results("SELECT * FROM " . $tableName . " WHERE id = '$id' LIMIT 1")[0];
            //var_dump($affiliate);
        }else{
            //get most recent index
            $link_index = get_option('refer_affiliate_link_index');
            if(!$link_index){
                $link_index = 0;
                update_option('refer_affiliate_link_index', $link_index);
            }  

            $rows = $wpdb->get_results("SELECT * FROM " . $tableName );

            if( array_key_exists($link_index, $rows) ){
                $affiliate = $rows[$link_index];
            }else{
                error_log( "can't find index $link_index in " );
                error_log( print_r($rows, true) );
                $affiliate = false;
            }
			//var_dump($affiliate);
            //increment link index
            $link_index ++;
            if( $link_index >= $wpdb->num_rows)
                $link_index = 0;

            update_option('refer_affiliate_link_index', $link_index);
            //var_dump($link_index);
        }

        if(is_object($affiliate)){
            if( property_exists($affiliate, 'url')){

                // error_log( print_r($affiliate, true) );
                
                if( NULL != $affiliate->type  &&  0 != $affiliate->type ){
                    $link_type = $affiliate->type;
                }else{
                    $link_type = $GLOBALS['income_school']['refer_affiliates']->determine_affiliate_link_type($affiliate->url);
                    if( $link_type ){
                        $wpdb->update($tableName, ['type' => $link_type ], ['id' => $affiliate->id ] );
                    }
                }

                switch ($link_type) {

                    case 'amazon':
                        error_log( "checking amazon API for " . $affiliate->url );

                        $refer_amazon_affiliate_id = get_option('refer_amazon_affiliate_id');

                        if( !$refer_amazon_affiliate_id){
                            $status = 'error';
                            $message = 'You must first set your Affiliate ID before using the Amazon API to check availability. See <a href="' . get_site_url() . '"/wp-admin/admin.php?page=affiliate-link-refer-api-settings">REFER API Settings</a>';
                        }

                        include_once AFFILIATE_LINK_REFER_PLUGIN_DIR . '/includes/class-amazon-product-checker.php';    
                        $asin = $this->getASIN($affiliate->url);

                        //vars for Amazon API
                        // $amazonItemRequest->PartnerType;
                        // $amazonItemRequest->PartnerTag;
                        // $amazonItemRequest->Keywords;
                        // $amazonItemRequest->SearchIndex;
                        // $amazonItemRequest->Resources;
                        $amazonItemRequest = (object) array();

                        if(false === $asin)
                            return false;

                        try {

                            //echo file_get_contents($affiliate->url);
                            $amazonItemRequest->PartnerType = "Associates";
                            // Put your Partner tag (Store/Tracking id) in place of Partner tag
                            $amazonItemRequest->PartnerTag = $refer_amazon_affiliate_id;
                            //$this->amazonItemRequest->PartnerTag = 'frdm-20';
                            //$this->amazonItemRequest->ItemIds = ["B01LWRQPWK"];
                            $amazonItemRequest->ItemIds = ["$asin"];
                            //$this->amazonItemRequest->Resources = ["Offers.Listings.Availability.Message","Offers.Listings.Availability.Type"];
                            $amazonItemRequest->Resources = ["Offers.Listings.Availability.Type"];
                            $host = "webservices.amazon.com";
                            $path = "/paapi5/searchitems";
                            $payload = json_encode ($amazonItemRequest);
                            //die($payload);

                            //Put your Access Key in place of <ACCESS_KEY> and Secret Key in place of <SECRET_KEY> in double quotes
                            $awsv4 = new AwsV4 ('AKIAJR24TYXSOAKLWOWQ', 'v5cHG7YUGoCO2KKyO/q+gDaU07SfEAnyzhRn82KW');
                            $awsv4->setRegionName("us-east-1");
                            $awsv4->setServiceName("ProductAdvertisingAPI");
                            $awsv4->setPath ($path);
                            $awsv4->setPayload ($payload);
                            $awsv4->setRequestMethod ("POST");
                            $awsv4->addHeader ('content-encoding', 'amz-1.0');
                            $awsv4->addHeader ('content-type', 'application/json; charset=utf-8');
                            $awsv4->addHeader ('host', $host);
                            $awsv4->addHeader ('x-amz-target', 'com.amazon.paapi5.v1.ProductAdvertisingAPIv1.GetItems');
                            $headers = $awsv4->getHeaders ();
                            $headerString = "";
                            foreach ( $headers as $key => $value ) {
                                $headerString .= $key . ': ' . $value . "\r\n";
                            }
                            $params = array (
                                    'http' => array (
                                        'header' => $headerString,
                                        'method' => 'POST',
                                        'content' => $payload
                                    )
                                );
                            $stream = stream_context_create ( $params );

                            //var_dump($headerString);
                            $fp = @fopen ( 'https://'.$host.$path, 'rb', false, $stream );

                            if (! $fp) {
                                error_log( print_r(error_get_last(), true) );
                                $status = "api-error";
                                $message = "An Error ocurred connecting to Amazon API";
                                break;
                            }
                            $response = @stream_get_contents ( $fp );
                            if ($response === false) {
                                error_log( print_r(error_get_last(), true) );
                                $status = "api-error";
                                $message = "An Error ocurred connecting to Amazon API";
                                break;
                            }
                            $response = json_decode($response, true);

                            // error_log( print_r($response, true) );

                            $item = $response['ItemsResult']['Items'][0];
                            $listings = $item['Offers']['Listings'];
                            //echo '<pre>';print_r($listings);echo '</pre>';
                            if(is_array($listings)) {
                                foreach($listings as $listing) {
                                    if($listing['Availability']['Type'] == 'Now') {//Valid Values: Now, Backorderable and Preorderable
                                        $status = "in-stock";
                                        break;
                                    }else{
                                        $status = "out-of-stock";
                                    }
                                }
                            }else{
                                $status = "out-of-stock";
                            }

                            //echo $status.$asin;
                            //echo '<pre>';print_r($response);echo '</pre>';
                        } catch (\Exception $e) {
                            //var_dump($e);
                            $status = "api-error";
                            $message = "An Error ocurred connecting to Amazon API";
                            break;
                        } 

                        break;
                        //end Amazon


                    case 'target':
                        error_log( "Checking Target API for " . $affiliate->url);

                        if( !$this->target_api_key){
                            $status = 'error';
                            $message = 'You must first set your API Key before using the Target API. See <a href="' . get_site_url() . '"/wp-admin/admin.php?page=affiliate-link-refer-api-settings">REFER API Settings</a>';
                            break;
                        }

                        $status = "out-of-stock";

                        /* set up the request parameters
                        * TY https://www.redcircleapi.com/docs/target-product-data-api/overview
                        * TY https://www.redcircleapi.com/docs/target-product-data-api/parameters/product
                        */

                        $queryString = http_build_query([
                          'api_key' => $this->target_api_key,
                          'type' => 'product',
                          'url' => $affiliate->url,
                          'output' => 'json',
                        ]);


                        # make the http GET request to RedCircle API
                        $ch = curl_init(sprintf('%s?%s', 'https://api.redcircleapi.com/request', $queryString));
                        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
                        curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
                        # the following options are required if you're using an outdated OpenSSL version
                        # more details: https://www.openssl.org/blog/blog/2021/09/13/LetsEncryptRootCertExpire/
                        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
                        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);

                        $api_result = curl_exec($ch);
                        curl_close($ch);

                        # print the JSON response from BlueCart API
                        $api_result = json_decode($api_result, true);

                        // error_log( print_r($api_result, true) );

                        if( !$api_result ){
                            $status = 'api-error';
                            $message = 'There was an error reaching the Target API.';
                            break;
                        }
                        // error_log( print_r( $api_result );

                        if( isset($api_result['product']) ){
                            // error_log( "one" );
                            if( isset($api_result['product']['buybox_winner']) ){
                                // error_log( "two" );
                                if( isset($api_result['product']['buybox_winner']['availability']) ){
                                    // error_log( "three" );
                                    if( isset($api_result['product']['buybox_winner']['availability']['in_stock']) ){
                                        if( $api_result['product']['buybox_winner']['availability']['in_stock'] == true || $api_result['product']['buybox_winner']['availability']['in_stock'] == 1 ){
                                            $status = "in-stock";
                                        }
                                    }
                                }
                            }
                        }

                        break;//end target

                        
                    case 'walmart':
                        error_log( "Checking Walmart API for " . $affiliate->url);

                        if( !$this->walmart_api_key){
                            $status = 'error';
                            $message = 'You must first set your API Key before using the Walmart API. See <a href="' . get_site_url() . '"/wp-admin/admin.php?page=affiliate-link-refer-api-settings">REFER API Settings</a>';
                            break;
                        }

                        $status = "out-of-stock";

                        /* set up the request parameters
                        * TY https://www.bluecartapi.com/docs/walmart-product-data-api/overview
                        */
                        $queryString = http_build_query([
                          'api_key' => $this->walmart_api_key,
                          'type' => 'product',
                          'url' => $affiliate->url,
                        ]);

                        # make the http GET request to BlueCart API
                        $ch = curl_init(sprintf('%s?%s', 'https://api.bluecartapi.com/request', $queryString));
                        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
                        curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
                        # the following options are required if you're using an outdated OpenSSL version
                        # more details: https://www.openssl.org/blog/blog/2021/09/13/LetsEncryptRootCertExpire/
                        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
                        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);

                        $api_result = curl_exec($ch);
                        curl_close($ch);

                        # print the JSON response from BlueCart API
                        $api_result = json_decode($api_result, true);

                        if( !$api_result ){
                            $status = 'api-error';
                            $message = 'There was an error reaching the Walmart API.';
                            break;
                        }
                        // error_log( print_r( $api_result );

                        if( isset($api_result['product']) ){
                            // error_log( "one" );
                            if( isset($api_result['product']['buybox_winner']) ){
                                // error_log( "two" );
                                if( isset($api_result['product']['buybox_winner']['availability']) ){
                                    // error_log( "three" );
                                    if( isset($api_result['product']['buybox_winner']['availability']['in_stock']) ){
                                        if( $api_result['product']['buybox_winner']['availability']['in_stock'] == true || $api_result['product']['buybox_winner']['availability']['in_stock'] == 1 ){
                                            $status = "in-stock";
                                        }
                                    }
                                }
                            }
                        }

                        break;//end walmart
                        
                    case 'self_hosted':
                        error_log( "Checking Self Hosted Products for " . $affiliate->url);

                        $urlParts = parse_url($affiliate->url);

                        //if not a woo product and not a 404 assume it's OK
                        $status = 'in-stock';

                        //if woocommerce is installed and the path contains 'product'
                        if( function_exists('wc_get_product') && strpos($urlParts['path'], 'product') ){
                            $product_id = url_to_postid( $affiliate->url );
                            $product_obj = wc_get_product( $product_id );

                            $status = 'four-oh-four';

                            if($product_obj != NULL){
                                if( $product_obj != false ){
                                    if($product_obj->get_stock_status() == 'in-stock') {
                                        $status = 'in-stock';
                                    }else{
                                         $status = 'out-of-stock';
                                    }
                                }
                            }
                        }

                        break;
                    
                    default:
                        error_log( "checking external link for " . $affiliate->url );
                        //for all external links, check the curl response to make sure it's a valid link

                        $curl = curl_init();
                        curl_setopt($curl, CURLOPT_URL, $affiliate->url);
                        curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
                        curl_setopt($curl, CURLOPT_FOLLOWLOCATION, true);
                        curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
                        $response = curl_exec($curl);
                        $code = curl_getinfo($curl, CURLINFO_HTTP_CODE);

                        $status = "out-of-stock";

                        if($code !== 200 && $code !== 503) { 
                            $status = 'not-allowed';
                        }else{
                            $status = 'in-stock';
                        }

                        break;

                }

                $last_checked = (int) strtotime('now');
                
                //var_dump($status);
                $wpdb->update($tableName, ['status' => $status , 'last_checked' => $last_checked], ['id' => $affiliate->id ] );

            }
        }

        return array(
            "status" => $status,
            "message" => $message,
        );

    }

    /**
     * [parsePostContentLinksOnSave description]
     * @param  [type] $postId [description]
     * @param  [type] $post   [description]
     * @param  [type] $update [description]
     * @return [type]         [description]
     */
    public function parsePostContentLinksOnSave($postId, $post, $update)
    {
        global $wpdb;

        if(!in_array($post->post_type, array('post', 'page'))) {
            return;
        }

        $content = $post->post_content;
        $contentUpdated = false;

        $amazonShortUrls = $this->parseShortlinks($content);

        //find any existing knowns and remove from array

        $knownTable = $wpdb->prefix . 'refer_amazon_shortlinks_known';

        foreach($amazonShortUrls as $url) {

            $knownShortlink = $wpdb->get_row($wpdb->prepare("
                SELECT *
                FROM $knownTable
                WHERE
                    short_link = %s
                LIMIT 1
            ", $url));

            if($knownShortlink) {
                //replace the link in the content
                unset($amazonShortUrls[$url]);
                $content = str_replace($url, $knownShortlink->full_link, $content);
                $contentUpdated = true;
            }
        }

        if(!empty($amazonShortUrls)) {

            $queueTable = $wpdb->prefix . 'refer_amazon_shortlinks_queue';

            $existsInQueue = $wpdb->get_row("
                SELECT *
                FROM $queueTable
                WHERE
                    post_id = $post->ID
                LIMIT 1
            ");

            if(!$existsInQueue) {
                $wpdb->insert($queueTable, [
                    'post_id' => $post->ID,
                    'created_date' => date('Y-m-d H:i:s')
                ]);
            }
        } else {
            update_post_meta($post->ID, '_refer_checked_amazon_shortlinks', 1);
        }

        if($contentUpdated) {
            $wpdb->update($wpdb->posts, array('post_content' => $content), array('ID' => $post->ID));
        }
    }

    /**
     * [parseWidgetContentLinksOnSave description]
     * @param  [type] $instance [description]
     * @param  [type] $new      [description]
     * @param  [type] $old      [description]
     * @param  [type] $object   [description]
     * @return [type]           [description]
     */
    public function parseWidgetContentLinksOnSave($instance, $new, $old, $object)
    {
        global $wpdb;

        $widgetType = $object->option_name;

        if(!in_array($widgetType, array('widget_text', 'widget_custom_html'))) {
            return $instance;
        }

        $content = false;
        if($widgetType == 'widget_text' && isset($instance['text'])) {
            $content = $instance['text'];
        } elseif($widgetType == 'widget_custom_html' && isset($instance['content'])) {
            $content = $instance['content'];
        }

        if(!$content) {
            return $instance;
        }

        $contentUpdated = false;

        $amazonShortUrls = $this->parseShortlinks($content);

        $knownTable = $wpdb->prefix . 'refer_amazon_shortlinks_known';

        foreach($amazonShortUrls as $url) {

            $knownShortlink = $wpdb->get_row($wpdb->prepare("
                SELECT *
                FROM $knownTable
                WHERE
                    short_link = %s
                LIMIT 1
            ", $url));

            if($knownShortlink) {
                //replace the link in the content
                unset($amazonShortUrls[$url]);
                $content = str_replace($url, $knownShortlink->full_link, $content);
                $contentUpdated = true;
            }
        }

        if($contentUpdated) {
            if($widgetType == 'widget_text') {
                $instance['text'] = $content;
            } elseif($widgetType == 'widget_custom_html') {
                $instance['content'] = $content;
            }
        }


        if(!empty($amazonShortUrls)) {

            $queueTable = $wpdb->prefix . 'refer_amazon_shortlinks_queue';

            $widgetId = $widgetType . ':' . $object->number;

            $existsInQueue = $wpdb->get_row("
                SELECT *
                FROM $queueTable
                WHERE
                    widget_id = '$widgetId'
                LIMIT 1
            ");

            if(!$existsInQueue) {
                $wpdb->insert($queueTable, [
                    'widget_id' => $widgetId,
                    'created_date' => date('Y-m-d H:i:s')
                ]);
            }
        }

        return $instance;
    }

    /**
     * [processConverterQueue description]
     * @return [type] [description]
     */
    public function processConverterQueue()
    {         
        global $wpdb;

        if($this->getVerfiedWorking() != 'yes') {
            error_log("not verified working");
            // $this->setVerfiedWorking(true);
            return;
        } elseif($this->getFailedCount() >= 5) {
            error_log("> 5 Failed Attempts");
            return;
        }

        $queueTable = $wpdb->prefix . 'refer_amazon_shortlinks_queue';

        $queueItems = $wpdb->get_results("
            SELECT *
            FROM $queueTable
            ORDER BY created_date ASC
            LIMIT 1
        ");

        error_log( print_r($queueItems, true) );

        foreach($queueItems  as $queueItem) {

            if(!is_null($queueItem->post_id)) {

                $post = get_post($queueItem->post_id);

                if($post) {

                    $content = $post->post_content;
                    $contentUpdated = false;

                    $amazonShortUrls = $this->parseShortlinks($content);

                    $replaceUrls = [];
                    $knownTable = $wpdb->prefix . 'refer_amazon_shortlinks_known';

                    foreach($amazonShortUrls as $url) {
                        $knownShortlink = $wpdb->get_row($wpdb->prepare("
                            SELECT *
                            FROM $knownTable
                            WHERE
                                short_link = %s
                            LIMIT 1
                        ", $url));

                        if( isset($queueItem->created_date)){
                            $process_time = strtotime("now") - strtotime($queueItem->created_date);
                        }else{
                            $process_time = false;
                        }

                        if($knownShortlink) {
                            $replaceUrls[$url] = $knownShortlink->full_link;
                        } else {
                            $finalUrl = $this->convert($url);
                            if($finalUrl) {
                                $wpdb->insert($knownTable, array(
                                    'short_link' => $url,
                                    'full_link' => $finalUrl,
                                    'process_time' => $process_time,
                                ));
                                $replaceUrls[$url] = $finalUrl;
                            }
                        }
                    }

                    foreach($replaceUrls as $oldUrl => $newUrl) {
                        $content = str_replace($oldUrl, $newUrl, $content);
                        $contentUpdated = true;
                    }

                    if($contentUpdated) {
                        $wpdb->update($wpdb->posts, array('post_content' => $content), array('ID' => $post->ID));
                    }

                    update_post_meta($post->id, '_refer_checked_amazon_shortlinks', 1);
                }
            } elseif(!is_null($queueItem->widget_id)) {

                $idParts = explode(':', $queueItem->widget_id);
                $widgetType = $idParts[0];
                $widgetNumber = isset($idParts[1]) ? $idParts[1] : false;

                if($widgetNumber) {
                    $widgetOptions = get_option($widgetType);
                    if(isset($widgetOptions[$widgetNumber])) {

                        $widgetData = $widgetOptions[$widgetNumber];

                        $content = false;
                        if($widgetType == 'widget_text' && isset($widgetData['text'])) {
                            $content = $widgetData['text'];
                        } elseif($widgetType == 'widget_custom_html' && isset($widgetData['content'])) {
                            $content = $widgetData['content'];
                        }

                        if($content) {

                            $contentUpdated = false;
                            $amazonShortUrls = $this->parseShortlinks($content);

                            $replaceUrls = [];
                            $knownTable = $wpdb->prefix . 'refer_amazon_shortlinks_known';

                            foreach($amazonShortUrls as $url) {
                                $knownShortlink = $wpdb->get_row($wpdb->prepare("
                                    SELECT *
                                    FROM $knownTable
                                    WHERE
                                        short_link = %s
                                    LIMIT 1
                                ", $url));

                                if($knownShortlink) {
                                    $replaceUrls[$url] = $knownShortlink->full_link;
                                } else {
                                    $finalUrl = $this->convert($url);
                                    if($finalUrl) {
                                        $wpdb->insert($knownTable, array(
                                            'short_link' => $url,
                                            'full_link' => $finalUrl
                                        ));
                                        $replaceUrls[$url] = $finalUrl;
                                    }
                                }
                            }

                            foreach($replaceUrls as $oldUrl => $newUrl) {
                                $content = str_replace($oldUrl, $newUrl, $content);
                                $contentUpdated = true;
                            }

                            if($contentUpdated) {
                                if($widgetType == 'widget_text') {
                                    $widgetData['text'] = $content;
                                } elseif($widgetType == 'widget_custom_html') {
                                    $widgetData['content'] = $content;
                                }

                                $widgetOptions[$widgetNumber] = $widgetData;
                                update_option($widgetType, $widgetOptions);
                            }
                        }
                    }

                    $alreadyChecked = get_option('refer_' . $widgetType . '_checked', array());
                    $alreadyChecked[] = $widgetNumber;
                    update_option('refer_' . $widgetType . '_checked', $alreadyChecked);
                }
            }

            $wpdb->delete($queueTable, array('id' => $queueItem->id));
        }
    }

    function queueOldPagesToConvert()
    {

        global $wpdb;

        $queueTable = $wpdb->prefix . 'refer_amazon_shortlinks_queue';

        //pages..
        $pages = get_posts(array(
            'post_type' => 'page',
            'posts_per_page' => 40,
            'meta_query' => array(
                array(
                    'key' => '_refer_checked_amazon_shortlinks',
                    'compare' => 'NOT EXISTS',
                )
            )
        ));

        foreach($pages as $page) {
            $this->parsePostContentLinksOnSave($page->ID, $page, false);
        }


        $posts = get_posts(array(
            'post_type' => 'post',
            'posts_per_page' => 40,
            'meta_query' => array(
                array(
                    'key' => '_refer_checked_amazon_shortlinks',
                    'compare' => 'NOT EXISTS',
                )
            )
        ));

        foreach($posts as $post) {
             $this->parsePostContentLinksOnSave($post->ID, $post, false);
        }


        $htmlTextWidgets = get_option('widget_custom_html');
        $alreadyChecked = get_option('refer_widget_custom_html_checked', array());
        foreach($htmlTextWidgets as $id => $widget) {
            if(is_numeric($id) && !in_array($id, $alreadyChecked)) {
                $widgetId = 'widget_custom_html:' .  $id;

                $existsInQueue = $wpdb->get_row("
                    SELECT *
                    FROM $queueTable
                    WHERE
                        widget_id = '$widgetId'
                    LIMIT 1
                ");

                if(!$existsInQueue) {
                    $wpdb->insert($queueTable, [
                        'widget_id' => $widgetId,
                        'created_date' => date('Y-m-d H:i:s')
                    ]);
                }
            }
        }

        $textWidgets = get_option('widget_text');
        $alreadyChecked = get_option('refer_widget_text_checked', array());
        foreach($textWidgets as $id => $widget) {
            if(is_numeric($id) && !in_array($id, $alreadyChecked)) {
                $widgetId = 'widget_text:' .  $id;

                $existsInQueue = $wpdb->get_row("
                    SELECT *
                    FROM $queueTable
                    WHERE
                        widget_id = '$widgetId'
                    LIMIT 1
                ");

                if(!$existsInQueue) {
                    $wpdb->insert($queueTable, [
                        'widget_id' => $widgetId,
                        'created_date' => date('Y-m-d H:i:s')
                    ]);
                }
            }
        }
    }

    /**
     * [getASIN description]
     * @param  [type] url [description]
     * @return [type]          [description]
     */
    private function getASIN($url) {
        if(!$url)
            return false;
        
        $path = parse_url($url, PHP_URL_PATH);// should be something like /dp/ABC123
        $path = explode('/', $path);
        
        return $path[2];
    }
    
    
    
    /**
     * [parseShortlinksFromContent description]
     * @param  [type] $content [description]
     * @return [type]          [description]
     */
    public function parseShortlinks($content)
    {
        $urlMatches = [];
        preg_match_all('#\bhttps?://[^,\s()<>]+(?:\([\w\d]+\)|([^,[:punct:]\s]|/))#', $content, $urlMatches);
        $urlsToParse = [];
        foreach($urlMatches[0] as $match) {
            $urlsToParse[$match] = $match;
        }

        //error_log( $urlMatches );

        $amazonShortUrls = [];
        foreach($urlsToParse as $url) {
            $urlParts = parse_url($url);
            if(strpos($urlParts['host'], 'amzn.to') !== false) {
                $amazonShortUrls[$url] = $url;
            }
        }

        return $amazonShortUrls;
    }

    /**
     * [convert description]
     * @param  [type] $shortlink [description]
     * @return [type]            [description]
     */
    public function convert($shortlink)
    {
        if(!$this->verify($shortlink)) {
            return false;
        }

        try {

            $curl = curl_init();
            curl_setopt($curl, CURLOPT_URL, $shortlink);
            curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($curl, CURLOPT_FOLLOWLOCATION, true);
            curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
            $response = curl_exec($curl);
            $code = curl_getinfo($curl, CURLINFO_HTTP_CODE);

            if($code !== 200 && $code !== 503) { 
                $this->incrementFailedCount();
                return false;
            }

            $finalUrl = curl_getinfo($curl, CURLINFO_EFFECTIVE_URL);

            if($shortlink == $finalUrl) {
                return false;
            }

            $urlParts = parse_url($finalUrl);
            if(strpos($urlParts['host'], 'amazon') === false) {
                return false;
            }

        } catch (\Exception $e) {
            $this->incrementFailedCount();
            error_log("Exception: " . print_r($e, true));
            return false;
        }

        return $finalUrl;
    }

    public function getQueueCount()
    {
        global $wpdb;

        $queueTable = $wpdb->prefix . 'refer_amazon_shortlinks_queue';

        $count = $wpdb->get_var("
            SELECT count('id')
            FROM $queueTable
        ");

        return $count;
    }

    public function verify($shortlink)
    {
        $shortlink = $this->clean($shortlink);

        if(filter_var($shortlink, FILTER_VALIDATE_URL) === false) {
            error_log("Invalid URL (class-amazon-shortlink-converter.php)");
            return false;
        } else {
            $urlParts = parse_url($shortlink);
            if(strpos($urlParts['host'], 'amzn.to') === false) {
                error_log("Invalid URL (class-amazon-shortlink-converter.php)");
                return false;
            }
        }

        return true;
    }

    public function clean($shortlink)
    {
        return str_replace('http://', 'https://', trim(strtolower($shortlink)));
    }


    public function resetFailedCount()
    {
        return update_option('refer_amazon_shortlink_converter_failed_count', 0);
    }

    public function incrementFailedCount()
    {
        return update_option('refer_amazon_shortlink_converter_failed_count', $this->getFailedCount() + 1);
    }

    public function getFailedCount()
    {
        return get_option('refer_amazon_shortlink_converter_failed_count', 0);
    }

    public function setVerfiedWorking($working = true)
    {
        return update_option('refer_amazon_shortlink_converter_verified', $working ? 'yes' : 'no');
    }

    public function getVerfiedWorking()
    {
        return get_option('refer_amazon_shortlink_converter_verified', 'no') == 'yes';
    }
}
