<?php

namespace IncomeSchool\AffiliateLinkRefer;

class LegalDisclaimerDisplay {

    /**
     * [__construct description]
     */
    public function __construct() {

        if(!is_admin()) {
            // error_log("legal_disclaimers_top_of_post = " . get_option('legal_disclaimers_top_of_post'));
            if( get_option('legal_disclaimers_top_of_post') != '' ) {
                add_filter('the_content', array($this, 'legal_disclaimer_before_content'), 30, 1);
            }

            if( get_option('legal_disclaimers_bottom_of_post') != '' ) {
                add_filter('the_content', array($this, 'legal_disclaimer_after_content'), 35, 1);
            }

            if( get_option('legal_disclaimers_footer') != '' ) {
                add_action( 'wp_footer', function() {
                    echo sprintf('<p class="legal-disclaimer footer-disclaimer">%s</p>', get_option('legal_disclaimers_footer'));
                });
            }
            //Display Amazon Affiliate One Link Javascript Code in footer
            if( get_option('refer_amazon_onlink_code') != '' ) {
                add_action('wp_footer', function() {
                    echo stripslashes(get_option('refer_amazon_onlink_code', ''));
                });
            }
        }

        if( get_option('legal_disclaimers_sidebar') != '' ) {
            add_action( 'widgets_init', function() {
                register_widget( '\IncomeSchool\AffiliateLinkRefer\LegalDisclaimerWidget' );
            });
        }
    }

    function legal_disclaimer_before_content( $content )
    {

        if(is_single() && in_the_loop() && is_main_query()) {
            $custom_content = sprintf('<p class="legal-disclaimer">%s</p>%s', get_option('legal_disclaimers_top_of_post'), $content);
            return $custom_content;
        }
        else {
            return $content;
        }
    }

    function legal_disclaimer_after_content( $content )
    {

        if(is_single() && in_the_loop() && is_main_query()) {
            $custom_content = sprintf('%s<p class="legal-disclaimer">%s</p>', $content, get_option('legal_disclaimers_bottom_of_post'));
            return $custom_content;
        }
        else {
            return $content;
        }
    }
}
