<?php

namespace IncomeSchool\AffiliateLinkRefer;

class LinkRelay
{
    /**
     * [$code description]
     * @var string
     */
    private $getKey = 'als';

    /**
     * [__construct description]
     */
    public function __construct()
    {
        add_action('init', [$this, 'relay']);
    }

    /**
     * [relay description]
     * @return [type] [description]
     */
    public function relay()
    {
        global $wpdb;

        if(!isset($_GET[$this->getKey])) {
            return;
        }

        if(!isset($_GET['pid'])) {
            return;
        }

        $post = get_post($_GET['pid']);

        if(!$post) {
            return;
        }

        $tableName = $wpdb->prefix . 'refer_affiliate_links';

        $affiliate = $wpdb->get_row($wpdb->prepare("SELECT * FROM $tableName WHERE is_amazon = 0 AND hash = %s LIMIT 1", [$_GET[$this->getKey]]));

        if(!$affiliate) {
            return;
        }

        $url = $affiliate->url;

        if(!is_admin()) {
            $this->logClick($affiliate, $post);
        }

        wp_redirect($url);
        exit;
    }

    /**
     * [logClick description]
     * @param  [type] $affiliate [description]
     * @param  [type] $post      [description]
     * @return [type]            [description]
     */
    private function logClick($affiliate, $post)
    {
        global $wpdb;

        $userId = null;

        if(get_current_user_id()) {
            $userId = get_current_user_id();
        }

        $trackingTableName = $wpdb->prefix . 'refer_link_daily_trackings';

        $today = date('Y-m-d');

        $existingDaily = $wpdb->get_row("
            SELECT *
            FROM $trackingTableName
            WHERE
                link_id = $affiliate->id
            AND
                post_id = $post->ID
            AND
                date = '$today'
            LIMIT 1
        ");

        $is_amazon = property_exists($affiliate, 'is_amazon')? $affiliate->is_amazon : NULL;
        //hacky strpos TY https://stackoverflow.com/questions/6284553/using-an-array-as-needles-in-strpos
        $is_amazon = ( str_replace( array('amazon','amzn'), '', $affiliate->url) != $affiliate->url );

        if(!$existingDaily) {
            $wpdb->insert($trackingTableName, [
                'post_id' => $post->ID,
                'link_id' => $affiliate->id,
                'is_amazon' => $is_amazon,
                'clicks' => 1,
                'date' => $today
            ]);
        } else {
            $wpdb->update($trackingTableName, [
                'clicks' => $existingDaily->clicks+1,
                'is_amazon' => $is_amazon,
            ], [
                'id' => $existingDaily->id
            ]);
        }

        //store the single tracking record item.
        // $trackingTableName = $wpdb->prefix . 'refer_link_trackings';

        // $wpdb->insert($trackingTableName, [
        //     'post_id' => $post->ID,
        //     'user_id' => $userId,
        //     'link_id' => $affiliate->id,
        //     'type' => 'click',
        //     'created_at' => date('Y-m-d H:i:s')
        // ]);

        //store the 'cached' clicks total in the links table.
        //TODO: add background process to sync these totals to the record items.
        $affiliateTableName = $wpdb->prefix . 'refer_affiliate_links';

        $wpdb->update($affiliateTableName, [
            'clicks' => $affiliate->clicks + 1
        ], [
            'id' => $affiliate->id
        ]);

        return true;
    }
}
