<?php
/**
 * Plugin Name: 	REFER Links
 * 
 * Description: 	We make adding and tracking your affiliate links each, with all your links in on place with insightful metrics and reports. Amazon links are automatically detected, optimized, and tracked. Save time with your affiliate links!
 * Version: 		2.2.0
 * Author: 		Income School
 * Author URI: 		https://incomeschool.com
 *
 */

defined( 'ABSPATH' ) || exit;

define( 'AFFILIATE_LINK_REFER_PLUGIN_FILE', __FILE__ );
define( 'AFFILIATE_LINK_REFER_PLUGIN_DIR', dirname(__FILE__));
define( 'AFFILIATE_LINK_REFER_PLUGIN_URL', plugin_dir_url(__FILE__));

define( 'AFFILIATE_LINK_REFER_VERSION', '2.2.0');
define( 'AFFILIATE_LINK_NOTIFICATION_SERVER', 'https://incomeschool.com');

if(!function_exists('dd')) {
    function dd()  {
        array_map(function($x) {
            echo '<pre>';
            if(is_bool($x)) {
                echo $x ? 'true' : 'false';
            } else {
                print_r($x);
            }
            echo '</pre>';
        }, func_get_args());
        die;
    }
}

if (!function_exists('write_log')) {
    function write_log ( $log )  {
        if ( true === WP_DEBUG ) {
            if ( is_array( $log ) || is_object( $log ) ) {
                error_log( print_r( $log, true ) );
            } else {
                error_log( $log );
            }
        }
    }
}

if(!class_exists('\IncomeSchool\AffiliateLinkRefer\Main') ) {
    include_once AFFILIATE_LINK_REFER_PLUGIN_DIR . '/includes/class-main.php';
}

$GLOBALS['income_school']['refer_affiliates'] = new \IncomeSchool\AffiliateLinkRefer\Main();

if(!function_exists('AffiliateLinkRefer')) {
    function AffiliateLinkRefer()  {
        return $GLOBALS['income_school']['refer_affiliates'];
    }
}

register_activation_hook(__FILE__, ['\IncomeSchool\AffiliateLinkRefer\Main', 'pluginActivate']);
register_deactivation_hook(__FILE__, ['\IncomeSchool\AffiliateLinkRefer\Main', 'pluginDeactivate']);
